R0 = normal program counter
R1 = interrupt program counter
R2 = stack pointer
R3 = return address
R4 = call function
R5 = return function
R6-Rc = pointer into ram (20xx)
Rd-Rf = general purpose address registers

EF4 = test button

0000  ;$14e1 
0000 71      DIS     
0001 00      IDL     
0002 c01000  LBR      1000

0005  ;$0015
0005 d0      SEP      R0

0006  ;=Code for enter subroutine (D4)
0006 93      GHI      R3
0007 22      DEC      R2
0008 52      STR      R2
0009 83      GLO      R3
000a 22      DEC      R2
000b 52      STR      R2               ; [--r2]:=R3  : save R3 on stack
000c 22      DEC      R2               ; extra byte on stack

000d 90      GHI      R0
000e b3      PHI      R3
000f 80      GLO      R0
0010 a3      PLO      R3               ; R3:=R0

0011 43      LDA      R3
0012 b0      PHI      R0
0013 43      LDA      R3
0014 a0      PLO      R0               ; R0:=[R3++]
0015 3005    BR       0005

0017  ;$0021
0017 d0      SEP      R0

0018  ;=code for return from subroutine (D5)
0018 12      INC      R2               ; extra byte on stack
0019 93      GHI      R3               ; R0:=R3
001a b0      PHI      R0
001b 83      GLO      R3
001c a0      PLO      R0

001d 42      LDA      R2               ; R3:=[R2++]
001e a3      PLO      R3
001f 42      LDA      R2
0020 b3      PHI      R3

0021 3017    BR       0017

0023  ;=end of interrupt service routine (entered with P=0)
0023  ;$03b8 038a 033c 0336 0330 0325 0308 02fb 02f2 018e 006c
0023 e2      SEX      R2
0024 12      INC      R2
0025 72      LDXA    
0026 af      PLO      Rf
0027 72      LDXA    
0028 bf      PHI      Rf               ; pop Rf
0029 72      LDXA
002a ae      PLO      Re
002b 72      LDXA    
002c be      PHI      Re               ; pop Re
002d 72      LDXA
002e aa      PLO      Ra               ; pop Ra.0
002f 72      LDXA
0030 a9      PLO      R9               ; pop R9.0
0031 72      LDXA
0032 a8      PLO      R8               ; pop R8.0
0033 90      GHI      R0
0034 b1      PHI      R1
0035 f839    LDI      #39
0037 a1      PLO      R1               ; R1:=R0.1,39
0038 d1      SEP      R1

0039 42      LDA      R2
003a a0      PLO      R0
003b 42      LDA      R2
003c b0      PHI      R0               ; R0:=[R2++]
003d 42      LDA      R2
003e 76      SHRC                      ; restore df
003f 42      LDA      R2               ; restore data reg
0040 7a      REQ                       ; clear Q
0041 70      RET                       ; X,P=[Rx++] IE=1

0042   ;*IRQ service routine (R1==0042)
0042 22      DEC      R2               ; [--Rx]=orig X,P
0043 78      SAV
0044 22      DEC      R2
0045 73      STXD                      ; [--Rx]=data
0046 7e      SHLC
0047 73      STXD                      ; [--Rx]=df
0048 90      GHI      R0
0049 73      STXD    
004a 80      GLO      R0
004b 73      STXD                      ; [--Rx]=R0
004c 88      GLO      R8
004d 73      STXD                      ; [--Rx]=R8.0
004e 89      GLO      R9
004f 73      STXD                      ; [--Rx]=R9.0
0050 8a      GLO      Ra
0051 73      STXD                      ; [--Rx]=Ra.0
0052 9e      GHI      Re
0053 73      STXD    
0054 8e      GLO      Re
0055 73      STXD                      ; [--Rx]=Re
0056 9f      GHI      Rf
0057 73      STXD    
0058 8f      GLO      Rf
0059 73      STXD                      ; [--Rx]=Rf    rx--
005a 91      GHI      R1
005b b0      PHI      R0
005c f860    LDI      #60
005e a0      PLO      R0               ; R0:=R1.1, 60
005f d0      SEP      R0

0060  ;=Now running inside interrupt, with P=0
0060 f847    LDI      #47              ; R8=2047
0062 a8      PLO      R8
0063 e8      SEX      R8
0064 08      LDN      R8
0065 fb01    XRI      #01
0067 3a6e    BNZ      006e
0069 f802    LDI      #02              ; if [2047]==01 -> [2047]=2
006b 58      STR      R8               ;   return
006c 3023    BR       0023

006e  ;$0067
006e f893    LDI      #93              ; R8=2093
0070 a8      PLO      R8
0071 08      LDN      R8
0072 fc01    ADI      #01
0074 58      STR      R8               ; [2093]++
0075 ff32    SMI      #32
0077 3b94    BNF      0094             ; if  [2093]>= 50dec

0079 f800    LDI      #00
007b 58      STR      R8               ; [2093]=0
007c f89f    LDI      #9f              ; R8=209f
007e a8      PLO      R8
007f 48      LDA      R8               ; if word[209f]
0080 f1      OR
0081 328b    BZ       008b
0083 08      LDN      R8               ;     decrement word[209f]
0084 ff01    SMI      #01              ;         (hi/lo)
0086 73      STXD    
0087 08      LDN      R8
0088 7f00    SMBI     #00
008a 58      STR      R8

008b  ;$0081
008b f892    LDI      #92              ; R8=2092
008d a8      PLO      R8
008e 08      LDN      R8
008f 3294    BZ       0094             ; if nonzero decrement B[2092]
0091 ff01    SMI      #01
0093 58      STR      R8

0094  ;$008f 0077
0094 f804    LDI      #04              ; loop 4 times
0096 af      PLO      Rf
0097 f891    LDI      #91              ; R8=2091
0099 a8      PLO      R8
009a  ;$00a1
009a 08      LDN      R8               ; if nonzero decrement B[2091] .. 208e
009b ce      LSZ
009c ff01    SMI      #01
009e 73      STXD    
009f 2f      DEC      Rf
00a0 8f      GLO      Rf
00a1 3a9a    BNZ      009a

00a3 f88d    LDI      #8d              ; R8=208d
00a5 a8      PLO      R8
00a6 08      LDN      R8
00a7 fbff    XRI      #ff
00a9 32b9    BZ       00b9             ; if B[208d]!=..ff
00ab 08      LDN      R8
00ac 28      DEC      R8
00ad f1      OR      
00ae 32b9    BZ       00b9             ;   &&  W[208c]!=0000
00b0 08      LDN      R8
00b1 ff01    SMI      #01              ;   W[208c]--   (lohi)
00b3 58      STR      R8
00b4 18      INC      R8
00b5 08      LDN      R8
00b6 7f00    SMBI     #00
00b8 58      STR      R8

00b9  ;$00ae 00a9
00b9 f88b    LDI      #8b              ; R8=208b
00bb a8      PLO      R8
00bc 08      LDN      R8
00bd fbff    XRI      #ff
00bf 32cb    BZ       00cb
00c1 28      DEC      R8
00c2 08      LDN      R8
00c3 fc01    ADI      #01
00c5 58      STR      R8
00c6 18      INC      R8
00c7 08      LDN      R8
00c8 7c00    ADCI     #00
00ca 58      STR      R8

00cb  ;$00bf
00cb f888    LDI      #88              ; R8=2088
00cd a8      PLO      R8
00ce f889    LDI      #89              ; R9=2089
00d0 a9      PLO      R9
00d1 f802    LDI      #02              ; Ra=2002
00d3 aa      PLO      Ra
00d4 09      LDN      R9
00d5 32e9    BZ       00e9

00d7 08      LDN      R8
00d8 fc01    ADI      #01
00da 58      STR      R8
00db ff19    SMI      #19
00dd 3bf1    BNF      00f1

00df 08      LDN      R8
00e0 ff32    SMI      #32
00e2 3bec    BNF      00ec
00e4 f800    LDI      #00
00e6 58      STR      R8
00e7 30f1    BR       00f1

00e9  ;$00d5
00e9 f800    LDI      #00
00eb 58      STR      R8
00ec  ;$00e2
00ec 0a      LDN      Ra
00ed f908    ORI      #08
00ef 30f4    BR       00f4

00f1  ;$00e7 00dd
00f1 0a      LDN      Ra
00f2 faf7    ANI      #f7

00f4  ;$00ef
00f4 5a      STR      Ra

00f5 f885    LDI      #85              ; R8=2085
00f7 a8      PLO      R8
00f8 08      LDN      R8
00f9 c2013f  LBZ      013f             ; ==0  || >=2  -> 13f
00fc ff02    SMI      #02
00fe c3013f  LBDF     013f

0101 f894    LDI      #94              ; R8=2094
0103 a8      PLO      R8
0104 08      LDN      R8
0105 fa02    ANI      #02
0107 3a3f    BNZ      013f

0109 f89f    LDI      #9f              ; R8=209f
010b a8      PLO      R8
010c 48      LDA      R8
010d 3a3f    BNZ      013f
010f 08      LDN      R8
0110 fb01    XRI      #01              ;  Whl[209f]==1
0112 3a3f    BNZ      013f

0114 f812    LDI      #12              ; R9=2012
0116 a9      PLO      R9
0117 49      LDA      R9
0118 58      STR      R8               ;
0119 28      DEC      R8
011a 09      LDN      R9
011b 58      STR      R8

011c f816    LDI      #16              ; R8=2016
011e a8      PLO      R8
011f f800    LDI      #00
0121 58      STR      R8
0122 18      INC      R8
0123 58      STR      R8               ; W[2016]=0

0124 f884    LDI      #84              ; R8=2084
0126 a8      PLO      R8
0127 08      LDN      R8
0128 fc01    ADI      #01
012a 58      STR      R8               ; B[2084]++

012b f8a1    LDI      #a1              ; R8=20a1
012d a8      PLO      R8
012e 58      STR      R8

012f f88a    LDI      #8a              ; R8=208a
0131 a8      PLO      R8
0132 f886    LDI      #86              ; R9=2086
0134 a9      PLO      R9

0135 48      LDA      R8
0136 59      STR      R9
0137 19      INC      R9
0138 08      LDN      R8
0139 59      STR      R9

013a e8      SEX      R8
013b f800    LDI      #00
013d 73      STXD    
013e 73      STXD    

013f  ;$0112 010d 0107 00fe 00f9
013f f851    LDI      #51              ; R8=2051
0141 a8      PLO      R8
0142 08      LDN      R8
0143 fe      SHL     
0144 58      STR      R8

0145 e2      SEX      R2
0146 6a      INP      D2
0147 6c      INP      D4
0148 6c      INP      D4
0149 6c      INP      D4
014a 6c      INP      D4
014b fe      SHL     
014c 3367    BDF      0167
014e 08      LDN      R8
014f f901    ORI      #01
0151 58      STR      R8
0152 fb0f    XRI      #0f
0154 3a67    BNZ      0167
0156 f806    LDI      #06              ; R8=2006
0158 a8      PLO      R8
0159 08      LDN      R8
015a fa08    ANI      #08
015c 3a63    BNZ      0163
015e 08      LDN      R8
015f f908    ORI      #08
0161 3066    BR       0166

0163  ;$015c
0163 08      LDN      R8
0164 faf7    ANI      #f7
0166  ;$0161
0166 58      STR      R8

0167  ;$0154 014c
0167 f801    LDI      #01              ; R8=2001
0169 a8      PLO      R8
016a e8      SEX      R8
016b 61      OUT      D1
016c 61      OUT      D1
016d 61      OUT      D1
016e 61      OUT      D1
016f 61      OUT      D1
0170 61      OUT      D1
0171 61      OUT      D1
0172 61      OUT      D1
0173 65      OUT      D5
0174 66      OUT      D6
0175 62      OUT      D2
0176 63      OUT      D3
0177 64      OUT      D4
0178 f808    LDI      #08              ; R8=2008
017a a8      PLO      R8

017b f808    LDI      #08
017d af      PLO      Rf
017e  ;$0184
017e 08      LDN      R8
017f fa0d    ANI      #0d
0181 73      STXD    
0182 2f      DEC      Rf
0183 8f      GLO      Rf
0184 3a7e    BNZ      017e

0186 f847    LDI      #47              ; R8=2047
0188 a8      PLO      R8
0189 e8      SEX      R8
018a 08      LDN      R8
018b 3291    BZ       0191
018d 67      OUT      D7
018e c00023  LBR      0023

0191  ;$018b
0191 f8a1    LDI      #a1              ; R8=20a1
0193 a8      PLO      R8
0194 08      LDN      R8
0195 329b    BZ       019b
0197 67      OUT      D7
0198 c00255  LBR      0255

019b  ;$0195
019b f881    LDI      #81              ; R8=2081
019d a8      PLO      R8
019e f8ff    LDI      #ff
01a0 af      PLO      Rf
01a1  ;$0252 01d4 01c7
01a1 f885    LDI      #85              ; R9=2085
01a3 a9      PLO      R9
01a4 f849    LDI      #49              ; Ra=2049
01a6 aa      PLO      Ra
01a7 e8      SEX      R8
01a8 18      INC      R8
01a9 1f      INC      Rf
01aa 8f      GLO      Rf
01ab ff02    SMI      #02
01ad 33b4    BDF      01b4
01af 0a      LDN      Ra
01b0 f6      SHR     
01b1 33b7    BDF      01b7
01b3 67      OUT      D7
01b4  ;$01ad
01b4 c00255  LBR      0255

01b7  ;$01b1
01b7 08      LDN      R8
01b8 fe      SHL     
01b9 58      STR      R8
01ba 8f      GLO      Rf
01bb f6      SHR     
01bc 33c4    BDF      01c4
01be 36cf    B3       01cf
01c0 67      OUT      D7
01c1 28      DEC      R8
01c2 30cb    BR       01cb

01c4  ;$01bc
01c4 0a      LDN      Ra
01c5 f6      SHR     
01c6 f6      SHR     
01c7 3ba1    BNF      01a1
01c9 37cf    B4       01cf
01cb  ;$01c2
01cb 08      LDN      R8
01cc f901    ORI      #01
01ce 58      STR      R8
01cf  ;$01c9 01be
01cf 08      LDN      R8
01d0 fa0f    ANI      #0f
01d2 fb03    XRI      #03
01d4 3aa1    BNZ      01a1
01d6 f812    LDI      #12              ; R9=2012
01d8 a9      PLO      R9
01d9 f8a0    LDI      #a0              ; Ra=20a0
01db aa      PLO      Ra
01dc 49      LDA      R9
01dd 5a      STR      Ra
01de 2a      DEC      Ra
01df 09      LDN      R9
01e0 5a      STR      Ra
01e1 f885    LDI      #85              ; R9=2085
01e3 a9      PLO      R9
01e4 09      LDN      R9
01e5 fe      SHL     
01e6 c30206  LBDF     0206
01e9 09      LDN      R9
01ea fc01    ADI      #01
01ec 59      STR      R9
01ed f8a2    LDI      #a2              ; R9=20a2
01ef a9      PLO      R9
01f0 09      LDN      R9
01f1 fa01    ANI      #01
01f3 c20206  LBZ      0206
01f6 09      LDN      R9
01f7 fa80    ANI      #80
01f9 c20236  LBZ      0236
01fc f800    LDI      #00
01fe 59      STR      R9
01ff f884    LDI      #84              ; R9=2084
0201 a9      PLO      R9
0202 09      LDN      R9
0203 fc01    ADI      #01
0205 59      STR      R9
0206  ;$01f3 01e6 
0206 f884    LDI      #84              ; R9=2084
0208 a9      PLO      R9
0209 09      LDN      R9
020a fc01    ADI      #01
020c 59      STR      R9
020d  ;$023a
020d e9      SEX      R9
020e 8f      GLO      Rf
020f ca0240  LBNZ     0240
0212 f8e9    LDI      #e9              ; R9=20e9
0214 a9      PLO      R9
0215 09      LDN      R9
0216 fc01    ADI      #01
0218 59      STR      R9
0219 ff0a    SMI      #0a
021b 3b40    BNF      0240
021d f800    LDI      #00
021f 73      STXD    
0220 29      DEC      R9
0221 f80f    LDI      #0f
0223 f5      SD      
0224 19      INC      R9
0225 f827    LDI      #27
0227 75      SDB     
0228 333c    BDF      023c
022a 29      DEC      R9
022b f801    LDI      #01
022d f4      ADD     
022e 59      STR      R9
022f 19      INC      R9
0230 f800    LDI      #00
0232 74      ADC     
0233 59      STR      R9
0234 3040    BR       0240

0236  ;$01f9 
0236 09      LDN      R9
0237 f980    ORI      #80
0239 59      STR      R9
023a 300d    BR       020d

023c  ;$0228
023c f800    LDI      #00
023e 73      STXD    
023f 59      STR      R9
0240  ;$0234 021b 020f
0240 f88a    LDI      #8a              ; R9=208a
0242 a9      PLO      R9
0243 f886    LDI      #86              ; Ra=2086
0245 aa      PLO      Ra
0246 49      LDA      R9
0247 5a      STR      Ra
0248 1a      INC      Ra
0249 09      LDN      R9
024a 5a      STR      Ra
024b f800    LDI      #00
024d 73      STXD    
024e 73      STXD    
024f 8f      GLO      Rf
0250 ff02    SMI      #02
0252 cb01a1  LBNF     01a1
0255  ;$01b4 0198 
0255 f848    LDI      #48              ; R8=2048
0257 a8      PLO      R8
0258 08      LDN      R8
0259 fa04    ANI      #04
025b 32f2    BZ       02f2
025d f875    LDI      #75              ; R8=2075
025f a8      PLO      R8
0260 08      LDN      R8
0261 fb74    XRI      #74
0263 3a67    BNZ      0267
0265 3df2    BN2      02f2
0267  ;$02ef 0263
0267 f899    LDI      #99              ; R8=2099
0269 a8      PLO      R8
026a e2      SEX      R2
026b f897    LDI      #97              ; R9=2097
026d a9      PLO      R9
026e f800    LDI      #00
0270 af      PLO      Rf
0271 6a      INP      D2
0272 09      LDN      R9
0273 327c    BZ       027c
0275 6c      INP      D4
0276 09      LDN      R9
0277 ff01    SMI      #01
0279 327c    BZ       027c
027b 6c      INP      D4
027c  ;$0279 0273
027c 6c      INP      D4
027d f6      SHR     
027e f6      SHR     
027f f6      SHR     
0280 f6      SHR     
0281  ;$028c
0281 32e5    BZ       02e5
0283 be      PHI      Re
0284 08      LDN      R8
0285 3af2    BNZ      02f2
0287 9e      GHI      Re
0288 f6      SHR     
0289 338e    BDF      028e
028b 1f      INC      Rf
028c 3081    BR       0281

028e  ;$0289
028e 3af2    BNZ      02f2
0290 f899    LDI      #99
0292 58      STR      R8
0293 f898    LDI      #98              ; R8=2098
0295 a8      PLO      R8
0296 09      LDN      R9
0297 fe      SHL     
0298 fe      SHL     
0299 58      STR      R8
029a 8f      GLO      Rf
029b e8      SEX      R8
029c f4      ADD     
029d 58      STR      R8
029e f831    LDI      #31
02a0 f4      ADD     
02a1 ae      PLO      Re
02a2 f817    LDI      #17
02a4 7c00    ADCI     #00
02a6 be      PHI      Re               ; Re=1731+...   keyboard xlat
02a7 f846    LDI      #46              ; Ra=2046
02a9 aa      PLO      Ra
02aa 0a      LDN      Ra
02ab f6      SHR     
02ac 3bb4    BNF      02b4
02ae f885    LDI      #85              ; Ra=2085
02b0 aa      PLO      Ra
02b1 0a      LDN      Ra
02b2 3ab9    BNZ      02b9
02b4  ;$02ac
02b4 0e      LDN      Re
02b5 ff0b    SMI      #0b
02b7 33f2    BDF      02f2
02b9  ;$02b2
02b9 f875    LDI      #75              ; Ra=2075
02bb aa      PLO      Ra
02bc f876    LDI      #76              ; R8=2076
02be a8      PLO      R8
02bf 0a      LDN      Ra
02c0 a9      PLO      R9
02c1 0e      LDN      Re               ;  store digit in buffer
02c2 59      STR      R9
02c3 0a      LDN      Ra
02c4 fb60    XRI      #60
02c6 3ad9    BNZ      02d9
02c8 f848    LDI      #48              ; R9=2048
02ca a9      PLO      R9
02cb 09      LDN      R9
02cc fa02    ANI      #02
02ce 32f2    BZ       02f2
02d0 08      LDN      R8
02d1 fb74    XRI      #74
02d3 32f2    BZ       02f2
02d5 f874    LDI      #74
02d7 30e2    BR       02e2

02d9  ;$02c6
02d9 0a      LDN      Ra
02da ff01    SMI      #01
02dc f3      XOR     
02dd 32f2    BZ       02f2
02df 0a      LDN      Ra
02e0 ff01    SMI      #01
02e2  ;$02d7
02e2 5a      STR      Ra
02e3 30f5    BR       02f5

02e5  ;$0281
02e5 f800    LDI      #00
02e7 58      STR      R8
02e8 e9      SEX      R9
02e9 f801    LDI      #01
02eb f4      ADD     
02ec 59      STR      R9
02ed ff03    SMI      #03
02ef 3a67    BNZ      0267
02f1 59      STR      R9
02f2  ;$02dd 02d3 02ce 02b7 028e 0285 0265 025b
02f2 c00023  LBR      0023

02f5  ;$02e3
02f5 f848    LDI      #48              ; Ra=2048
02f7 aa      PLO      Ra
02f8 0a      LDN      Ra
02f9 fa02    ANI      #02
02fb ca0023  LBNZ     0023
02fe f817    LDI      #17
0300 be      PHI      Re
0301 f800    LDI      #00
0303 ae      PLO      Re               ; Re=1700
0304  ;$0346 
0304 f874    LDI      #74              ; R8=2074
0306 a8      PLO      R8
0307 08      LDN      R8               ; if no digits in buffer IRET
0308 c20023  LBZ      0023
030b  ;$0313
030b e8      SEX      R8
030c 4e      LDA      Re
030d f3      XOR     
030e ca033f  LBNZ     033f             ; if no match next table entry
0311 28      DEC      R8
0312 08      LDN      R8               ; if more digits repeat
0313 3a0b    BNZ      030b
0315 0e      LDN      Re
0316 c2034c  LBZ      034c             ; if exact match -> 034c
0319 8e      GLO      Re
031a faf8    ANI      #f8              ; get function
031c fc07    ADI      #07
031e ae      PLO      Re
031f 0e      LDN      Re
0320 fe      SHL     
0321  ;$0349 
0321 f880    LDI      #80              ; Ra=2080
0323 aa      PLO      Ra
0324 0a      LDN      Ra               ;  if [2080] IRET
0325 ca0023  LBNZ     0023
0328 f894    LDI      #94              ; Ra=2094
032a aa      PLO      Ra
032b 3333    BDF      0333             ;
032d f880    LDI      #80              ; if function bit7 ==0
032f 5a      STR      Ra               ;      [2094]=80
0330 c00023  LBR      0023

0333  ;$032b
0333 88      GLO      R8
0334 ff6f    SMI      #6f
0336 ca0023  LBNZ     0023
0339 f801    LDI      #01              ; if 5 digits  [2094]=01
033b 5a      STR      Ra
033c c00023  LBR      0023             ; IRET

033f  ;$030e 
033f 8e      GLO      Re
0340 faf8    ANI      #f8
0342 fc08    ADI      #08
0344 ae      PLO      Re
0345 0e      LDN      Re               ; check if end of table
0346 ca0304  LBNZ     0304             ;   no : check next
0349 c00321  LBR      0321

034c  ;$0316 
034c 8e      GLO      Re
034d faf8    ANI      #f8
034f fc07    ADI      #07
0351 ae      PLO      Re
0352 0e      LDN      Re               ; get function
0353 fa7f    ANI      #7f
0355 52      STR      R2
0356 f894    LDI      #94              ; R8=2094
0358 a8      PLO      R8
0359 f880    LDI      #80              ; Ra=2080
035b aa      PLO      Ra
035c 0a      LDN      Ra               ; if [2080]==0
035d 3a8d    BNZ      038d
035f 02      LDN      R2
0360 327b    BZ       037b             ; [2094]=40   007
0362 ff01    SMI      #01              ; [2094]=41   060407
0364 327e    BZ       037e             ; [2094]=80   068008
0366 ff01    SMI      #01              ; [2094]=43   0611
0368 3281    BZ       0381             ; [2094]=80   007
036a ff01    SMI      #01              ; [2094]=80   008      [20a2]=1
036c 3284    BZ       0384
036e ff01    SMI      #01
0370 3287    BZ       0387
0372 f8a2    LDI      #a2              ; Ra=20a2
0374 aa      PLO      Ra
0375 f801    LDI      #01
0377 5a      STR      Ra
0378 f880    LDI      #80
037a c8      LSKP    
037b  ;$0360
037b f840    LDI      #40
037d c8      LSKP    
037e  ;$0364
037e f841    LDI      #41
0380 c8      LSKP    
0381  ;$0368
0381 f880    LDI      #80
0383 c8      LSKP    
0384  ;$036c
0384 f843    LDI      #43
0386 c8      LSKP    
0387  ;$0370
0387 f880    LDI      #80
0389 58      STR      R8
038a c00023  LBR      0023

038d  ;$035d                           ; if [2080]!=0
038d 02      LDN      R2
038e 32a9    BZ       03a9
0390 ff01    SMI      #01              ; [2094]=00   007
0392 32ac    BZ       03ac             ; [2094]=01   060407
0394 ff01    SMI      #01              ; [2094]=03   068008
0396 32af    BZ       03af             ; [2094]=03   0611
0398 ff01    SMI      #01              ; [2094]=20   007
039a 32b2    BZ       03b2             ; [2094]=20   008      [20a2]=1
039c ff01    SMI      #01
039e 32b5    BZ       03b5
03a0 f8a2    LDI      #a2              ; Ra=20a2
03a2 aa      PLO      Ra
03a3 f801    LDI      #01
03a5 5a      STR      Ra
03a6 f820    LDI      #20
03a8 c8      LSKP    
03a9  ;$038e
03a9 f800    LDI      #00
03ab c8      LSKP    
03ac  ;$0392
03ac f801    LDI      #01
03ae c8      LSKP    
03af  ;$0396
03af f803    LDI      #03
03b1 c8      LSKP    
03b2  ;$039a
03b2 f803    LDI      #03
03b4 c8      LSKP    
03b5  ;$039e
03b5 f820    LDI      #20
03b7 58      STR      R8
03b8 c00023  LBR      0023
             

03bb  ;=start of non-irq code
03bb  ;$1237 1166 059a 
03bb f848    LDI      #48              ; R7=2048
03bd a7      PLO      R7
03be 07      LDN      R7
03bf f908    ORI      #08
03c1 faf9    ANI      #f9
03c3 57      STR      R7
03c4 17      INC      R7
03c5 f800    LDI      #00
03c7 57      STR      R7
03c8 f806    LDI      #06
03ca ac      PLO      Rc
03cb 0c      LDN      Rc
03cc f902    ORI      #02
03ce 5c      STR      Rc
03cf f801    LDI      #01
03d1 ac      PLO      Rc
03d2 0c      LDN      Rc
03d3 f902    ORI      #02
03d5 5c      STR      Rc
03d6 1c      INC      Rc
03d7 1c      INC      Rc
03d8 0c      LDN      Rc
03d9 fa07    ANI      #07
03db 5c      STR      Rc
03dc f889    LDI      #89              ; R7=2089
03de a7      PLO      R7
03df 57      STR      R7
03e0 f80a    LDI      #0a              ; R6=200a
03e2 a6      PLO      R6
03e3 e6      SEX      R6
03e4 f888    LDI      #88
03e6 73      STXD    
03e7 56      STR      R6
03e8 16      INC      R6
03e9 f89e    LDI      #9e              ; R8=209e
03eb a8      PLO      R8
03ec f8ff    LDI      #ff
03ee 58      STR      R8
03ef  ;$03f4 
03ef 7b      SEQ     
03f0 d40e45  CALL     0e45             ; 209e<<ef4, status 204a (0,1 or 2)
03f3 08      LDN      R8
03f4 c203ef  LBZ      03ef
03f7 f6      SHR     
03f8 ca1358  LBNZ     1358
03fb  ;$040b 
03fb 7b      SEQ     
03fc f800    LDI      #00
03fe 57      STR      R7
03ff f84b    LDI      #4b              ; R8=204b
0401 a8      PLO      R8
0402 48      LDA      R8
0403 73      STXD    
0404 08      LDN      R8
0405 56      STR      R6
0406 16      INC      R6
0407 d40e45  CALL     0e45             ; 209e<<ef4, status 204a (0,1 or 2)
040a 08      LDN      R8
040b c203fb  LBZ      03fb
040e f6      SHR     
040f ca1358  LBNZ     1358
0412 f836    LDI      #36              ; R7=2036
0414 a7      PLO      R7
0415 f88e    LDI      #8e              ; Rb=208e
0417 ab      PLO      Rb
0418 f800    LDI      #00
041a 5b      STR      Rb
041b  ;$044a 0439 0428 
041b 7b      SEQ     
041c d40e45  CALL     0e45             ; 209e<<ef4, status 204a (0,1 or 2)
041f 08      LDN      R8
0420 f6      SHR     
0421 c3044d  LBDF     044d
0424 ca1358  LBNZ     1358
0427 0b      LDN      Rb
0428 ca041b  LBNZ     041b
042b 06      LDN      R6
042c fbff    XRI      #ff
042e c2043c  LBZ      043c
0431 f8ff    LDI      #ff
0433 73      STXD    
0434 56      STR      R6
0435 16      INC      R6
0436 f80d    LDI      #0d
0438 5b      STR      Rb
0439 c0041b  LBR      041b

043c  ;$042e 
043c 07      LDN      R7
043d 3a45    BNZ      0445
043f 56      STR      R6
0440 f836    LDI      #36              ; R7=2036
0442 a7      PLO      R7
0443 3047    BR       0447

0445  ;$043d
0445 56      STR      R6
0446 27      DEC      R7
0447  ;$0443
0447 f832    LDI      #32
0449 5b      STR      Rb
044a c0041b  LBR      041b

044d  ;$0421 
044d f8ff    LDI      #ff
044f 73      STXD    
0450 56      STR      R6
0451 16      INC      R6
0452 f846    LDI      #46              ; R7=2046
0454 a7      PLO      R7
0455 07      LDN      R7
0456 f901    ORI      #01
0458 57      STR      R7
0459 f885    LDI      #85              ; R7=2085
045b a7      PLO      R7
045c 57      STR      R7
045d f899    LDI      #99              ; R7=2099
045f a7      PLO      R7
0460 f875    LDI      #75              ; R9=2075
0462 a9      PLO      R9
0463 f874    LDI      #74
0465 59      STR      R9               ; R9=2074
0466 a9      PLO      R9
0467 f86f    LDI      #6f
0469 ae      PLO      Re
046a f817    LDI      #17
046c be      PHI      Re               ; Re=176f
046d f804    LDI      #04
046f ad      PLO      Rd
0470 f80b    LDI      #0b
0472 bd      PHI      Rd               ; Rd=0b04
0473 f800    LDI      #00
0475 bf      PHI      Rf
0476 5b      STR      Rb
0477 58      STR      R8
0478 57      STR      R7
0479 59      STR      R9
047a f848    LDI      #48              ; R7=2048
047c a7      PLO      R7
047d 07      LDN      R7
047e f906    ORI      #06
0480 57      STR      R7
0481  ;$0516 04e6
0481 7b      SEQ     
0482 08      LDN      R8
0483 3a88    BNZ      0488
0485 d40e45  CALL     0e45             ; 209e<<ef4, status 204a (0,1 or 2)
0488  ;$0483
0488 9f      GHI      Rf
0489 3a93    BNZ      0493
048b 08      LDN      R8
048c f6      SHR     
048d c30519  LBDF     0519
0490 ca1358  LBNZ     1358
0493  ;$0489
0493 0b      LDN      Rb
0494 3add    BNZ      04dd
0496 8e      GLO      Re
0497 fb72    XRI      #72
0499 32a7    BZ       04a7             ; end of 1st part ?
049b 8e      GLO      Re
049c fb76    XRI      #76              ; end of 2nd part ?
049e 3aad    BNZ      04ad
04a0 f86f    LDI      #6f
04a2 ae      PLO      Re
04a3 f817    LDI      #17
04a5 be      PHI      Re               ; Re=176f
04a6 38      SKP     
04a7  ;$0499
04a7 1e      INC      Re
04a8 f864    LDI      #64
04aa 5b      STR      Rb
04ab 30dd    BR       04dd

04ad  ;$049e
04ad f804    LDI      #04
04af ac      PLO      Rc
04b0 ec      SEX      Rc
04b1 9f      GHI      Rf
04b2 f6      SHR     
04b3 33c5    BDF      04c5
04b5 3ad1    BNZ      04d1
04b7 0c      LDN      Rc
04b8 f908    ORI      #08
04ba 5c      STR      Rc
04bb 0e      LDN      Re
04bc ac      PLO      Rc
04bd 8d      GLO      Rd
04be f1      OR      
04bf 5c      STR      Rc
04c0 f801    LDI      #01
04c2 bf      PHI      Rf
04c3 30cc    BR       04cc

04c5  ;$04b3
04c5 0c      LDN      Rc
04c6 fa07    ANI      #07
04c8 5c      STR      Rc
04c9 f802    LDI      #02
04cb bf      PHI      Rf
04cc  ;$04c3
04cc f802    LDI      #02
04ce 5b      STR      Rb
04cf 30dd    BR       04dd

04d1  ;$04b5
04d1 0e      LDN      Re
04d2 ac      PLO      Rc
04d3 9d      GHI      Rd
04d4 f2      AND     
04d5 5c      STR      Rc
04d6 f800    LDI      #00
04d8 bf      PHI      Rf
04d9 1e      INC      Re
04da f82e    LDI      #2e
04dc 5b      STR      Rb
04dd  ;$04cf 04ab 0494
04dd e6      SEX      R6
04de f875    LDI      #75              ; R7=2075
04e0 a7      PLO      R7
04e1 f874    LDI      #74              ; R7=2074
04e3 57      STR      R7
04e4 a7      PLO      R7
04e5 07      LDN      R7
04e6 3281    BZ       0481
04e8 ff0a    SMI      #0a
04ea c20500  LBZ      0500
04ed ff01    SMI      #01
04ef c20504  LBZ      0504
04f2 ff01    SMI      #01
04f4 c2050c  LBZ      050c
04f7 07      LDN      R7
04f8 56      STR      R6
04f9 fe      SHL     
04fa fe      SHL     
04fb fe      SHL     
04fc fe      SHL     
04fd f1      OR      
04fe 73      STXD    
04ff 38      SKP     
0500  ;$04ea 
0500 73      STXD    
0501 c00511  LBR      0511

0504  ;$04ef 
0504 f8ff    LDI      #ff
0506 73      STXD    
0507 f8f8    LDI      #f8
0509 c00511  LBR      0511

050c  ;$04f4 
050c f88f    LDI      #8f
050e 73      STXD    
050f f8ff    LDI      #ff
0511  ;$0509 0501 
0511 56      STR      R6
0512 16      INC      R6
0513 f800    LDI      #00
0515 57      STR      R7
0516 c00481  LBR      0481

0519  ;$048d 
0519 f840    LDI      #40
051b ac      PLO      Rc
051c f80f    LDI      #0f
051e bf      PHI      Rf
051f f80d    LDI      #0d
0521 5b      STR      Rb
0522 f8ff    LDI      #ff
0524 73      STXD    
0525 56      STR      R6
0526 16      INC      R6
0527  ;$0566 0545 0534 
0527 7b      SEQ     
0528 d40e45  CALL     0e45             ; 209e<<ef4, status 204a (0,1 or 2)
052b 08      LDN      R8
052c f6      SHR     
052d c30569  LBDF     0569
0530 ca1358  LBNZ     1358
0533 0b      LDN      Rb
0534 ca0527  LBNZ     0527
0537 06      LDN      R6
0538 fbff    XRI      #ff
053a c20548  LBZ      0548
053d f8ff    LDI      #ff
053f 73      STXD    
0540 56      STR      R6
0541 16      INC      R6
0542 f80d    LDI      #0d
0544 5b      STR      Rb
0545 c00527  LBR      0527

0548  ;$053a 
0548 8c      GLO      Rc
0549 fb46    XRI      #46
054b 3a53    BNZ      0553
054d f840    LDI      #40
054f ac      PLO      Rc
0550 f80f    LDI      #0f
0552 bf      PHI      Rf
0553  ;$054b
0553 9f      GHI      Rf
0554 fc10    ADI      #10
0556 bf      PHI      Rf
0557 73      STXD    
0558 0c      LDN      Rc
0559 ff0a    SMI      #0a
055b cf      LSDF    
055c 0c      LDN      Rc
055d c8      LSKP    
055e f910    ORI      #10
0560 1c      INC      Rc
0561 56      STR      R6
0562 16      INC      R6
0563 f832    LDI      #32
0565 5b      STR      Rb
0566 c00527  LBR      0527

0569  ;$052d 
0569 f8ff    LDI      #ff
056b 73      STXD    
056c 56      STR      R6
056d f803    LDI      #03              ; R6=2003
056f a6      PLO      R6
0570 06      LDN      R6
0571 f908    ORI      #08
0573 56      STR      R6
0574 f875    LDI      #75              ; R6=2075
0576 a6      PLO      R6
0577 f874    LDI      #74              ; *R6=74, R6=2074
0579 56      STR      R6
057a a6      PLO      R6
057b f89a    LDI      #9a              ; R8=209a
057d a8      PLO      R8
057e f800    LDI      #00
0580 56      STR      R6
0581 58      STR      R8
0582 18      INC      R8
0583 58      STR      R8
0584 5b      STR      Rb
0585 f877    LDI      #77
0587 ae      PLO      Re
0588 f817    LDI      #17
058a be      PHI      Re               ; Re=1777

058b  ;$0636 
058b 7b      SEQ     
058c f8fe    LDI      #fe
058e ad      PLO      Rd
058f f801    LDI      #01              ; Rd=01,fe
0591 bd      PHI      Rd               ;          xyz from tab[1777]
0592 d40f96  CALL     0f96             ; [2001..8]|=1,  [200x,y,z]&=fe
0595 d40e45  CALL     0e45             ; 209e<<ef4, status 204a (0,1 or 2)
0598 08      LDN      R8               ;  check status
0599 f6      SHR
059a c303bb  LBDF     03bb             ; if status==1 -> 03bb
059d ca1358  LBNZ     1358             ; if status==2 -> 1358
05a0 22      DEC      R2
05a1 e2      SEX      R2               ; *--R2=Re : push Re on stack
05a2 8e      GLO      Re
05a3 73      STXD    
05a4 9e      GHI      Re
05a5 73      STXD    
05a6 f89a    LDI      #9a              ; R7=209a
05a8 a7      PLO      R7
05a9 f875    LDI      #75              ; R6=2075
05ab a6      PLO      R6
05ac f874    LDI      #74              ; R6=2074
05ae 56      STR      R6
05af a6      PLO      R6
05b0 06      LDN      R6
05b1 c205fb  LBZ      05fb
05b4 ff01    SMI      #01
05b6 32cd    BZ       05cd
05b8 ff01    SMI      #01
05ba 32f0    BZ       05f0
05bc ff05    SMI      #05
05be c205f8  LBZ      05f8
05c1 ff02    SMI      #02
05c3 c2060a  LBZ      060a
05c6 ff01    SMI      #01
05c8 c205fe  LBZ      05fe
05cb 30ed    BR       05ed

05cd  ;$05b6
05cd d40d91  CALL     0d91             ; convert Wlh[20ea] -> BCD buf[209a]
05d0         DB       ea 9a

05d2  ;$05f5 
05d2 f80a    LDI      #0a              ; R9=200a
05d4 a9      PLO      R9
05d5 f8ff    LDI      #ff
05d7 73      STXD    
05d8 73      STXD    
05d9 d40d87  CALL     0d87             ; Q=1 for  0d clockticks
05dc         DB       0d

05dd d40dd7  CALL     0dd7
05e0         DB       9a

05e1 f8ed    LDI      #ed              ; R8=20ed
05e3 a8      PLO      R8
05e4 08      LDN      R8
05e5 fbaa    XRI      #aa
05e7 32ed    BZ       05ed
05e9 f889    LDI      #89              ; R8=2089
05eb a8      PLO      R8
05ec 58      STR      R8
05ed  ;$060d 0601 05e7 05cb
05ed c0062b  LBR      062b

05f0  ;$05ba
05f0 d40d91  CALL     0d91             ; convert Wlh[20e7] -> BCD buf[209a]
05f3         DB       e7 9a

05f5 c005d2  LBR      05d2

05f8  ;$05be 
05f8 f807    LDI      #07
05fa 57      STR      R7
05fb  ;$0607 05b1 
05fb c0062e  LBR      062e

05fe  ;$05c8 
05fe 07      LDN      R7
05ff fb07    XRI      #07
0601 ca05ed  LBNZ     05ed
0604 f80a    LDI      #0a
0606 57      STR      R7
0607 c005fb  LBR      05fb

060a  ;$05c3 
060a 07      LDN      R7
060b fb0a    XRI      #0a
060d ca05ed  LBNZ     05ed
0610 f8eb    LDI      #eb              ; R8=20eb
0612 a8      PLO      R8
0613 f80a    LDI      #0a              ; R9=200a
0615 a9      PLO      R9
0616 f889    LDI      #89              ; Ra=2089
0618 aa      PLO      Ra
0619 e9      SEX      R9
061a f800    LDI      #00
061c 73      STXD    
061d 73      STXD    
061e e8      SEX      R8
061f 73      STXD    
0620 73      STXD    
0621 73      STXD    
0622 73      STXD    
0623 73      STXD    
0624 5a      STR      Ra
0625 f8ed    LDI      #ed              ; Ra=20ed
0627 aa      PLO      Ra
0628 f8aa    LDI      #aa
062a 5a      STR      Ra
062b  ;$05ed 
062b f800    LDI      #00
062d 57      STR      R7
062e  ;$05fb 
062e f800    LDI      #00
0630 56      STR      R6
0631 12      INC      R2
0632 42      LDA      R2
0633 be      PHI      Re
0634 42      LDA      R2
0635 ae      PLO      Re               ; Re=*R2++
0636 c0058b  LBR      058b
             
0639  ;=zeroes upto 06ff

0700  ;*112b 
0700 f836    LDI      #36              ; R8=2036
0702 a8      PLO      R8
0703 f831    LDI      #31
0705 ad      PLO      Rd
0706 f89c    LDI      #9c              ; R9=209c
0708 a9      PLO      R9
0709 e2      SEX      R2
070a 6a      INP      D2
070b 6c      INP      D4
070c 59      STR      R9
070d 6c      INP      D4
070e e9      SEX      R9
070f f1      OR      
0710 59      STR      R9
0711 e2      SEX      R2
0712 6c      INP      D4
0713 e9      SEX      R9
0714 f1      OR      
0715 faf0    ANI      #f0
0717 e8      SEX      R8
0718 321c    BZ       071c
071a 8d      GLO      Rd
071b 73      STXD    
071c  ;$0718
071c 1d      INC      Rd
071d e9      SEX      R9
071e 67      OUT      D7
071f e8      SEX      R8
0720 3624    B3       0724
0722 8d      GLO      Rd
0723 73      STXD    
0724  ;$0720
0724 1d      INC      Rd
0725 f814    LDI      #14              ; R9=2014
0727 a9      PLO      R9
0728 e9      SEX      R9
0729 49      LDA      R9
072a f1      OR      
072b e8      SEX      R8
072c 3a30    BNZ      0730
072e 8d      GLO      Rd
072f 73      STXD    
0730  ;$072c
0730 1d      INC      Rd
0731 d409e7  CALL     09e7             ; compute ROM checksum
0734 e8      SEX      R8
0735 8e      GLO      Re
0736 323a    BZ       073a
0738 8d      GLO      Rd
0739 73      STXD    
073a  ;$0736
073a f838    LDI      #38              ; R9=2038
073c a9      PLO      R9
073d f805    LDI      #05
073f 59      STR      R9
0740 f800    LDI      #00
0742 af      PLO      Rf
0743 f811    LDI      #11
0745 ad      PLO      Rd
0746 f804    LDI      #04
0748 bd      PHI      Rd               ; Rd=0411
0749 e2      SEX      R2
074a 6a      INP      D2
074b ae      PLO      Re
074c  ;$07a7
074c e8      SEX      R8
074d 8e      GLO      Re
074e f6      SHR     
074f ae      PLO      Re
0750 3358    BDF      0758
0752 8d      GLO      Rd
0753 73      STXD    
0754 9d      GHI      Rd
0755 e9      SEX      R9
0756 f2      AND     
0757 59      STR      R9
0758  ;$0750
0758 1d      INC      Rd
0759 f805    LDI      #05              ; Ra=2005
075b aa      PLO      Ra
075c 0a      LDN      Ra
075d faf7    ANI      #f7
075f 5a      STR      Ra
0760 1a      INC      Ra
0761 1a      INC      Ra
0762 8f      GLO      Rf
0763 3a6c    BNZ      076c
0765 1a      INC      Ra
0766 0a      LDN      Ra
0767 f904    ORI      #04
0769 5a      STR      Ra
076a 3070    BR       0770

076c  ;$0763
076c 0a      LDN      Ra
076d f904    ORI      #04
076f 5a      STR      Ra
0770  ;$076a
0770 7b      SEQ     
0771 7b      SEQ     
0772 e2      SEX      R2
0773 6a      INP      D2
0774 fe      SHL     
0775 e8      SEX      R8
0776 337e    BDF      077e
0778 8d      GLO      Rd
0779 73      STXD    
077a 9d      GHI      Rd
077b e9      SEX      R9
077c f2      AND     
077d 59      STR      R9
077e  ;$0776
077e 1d      INC      Rd
077f f808    LDI      #08              ; Ra=2008
0781 aa      PLO      Ra
0782 ea      SEX      Ra
0783 0a      LDN      Ra
0784 fafb    ANI      #fb
0786 73      STXD    
0787 0a      LDN      Ra
0788 fafb    ANI      #fb
078a 73      STXD    
078b 2a      DEC      Ra
078c 0a      LDN      Ra
078d f908    ORI      #08
078f 73      STXD    
0790 7b      SEQ     
0791 8e      GLO      Re
0792 f6      SHR     
0793 ae      PLO      Re
0794 e8      SEX      R8
0795 339d    BDF      079d
0797 8d      GLO      Rd
0798 73      STXD    
0799 9d      GHI      Rd
079a e9      SEX      R9
079b f2      AND     
079c 59      STR      R9
079d  ;$0795
079d 8f      GLO      Rf
079e 3aa9    BNZ      07a9
07a0 f821    LDI      #21
07a2 ad      PLO      Rd
07a3 f801    LDI      #01
07a5 bd      PHI      Rd               ; Rd=0121
07a6 af      PLO      Rf
07a7 304c    BR       074c

07a9  ;$079e
07a9 f805    LDI      #05              ; Ra=2005
07ab aa      PLO      Ra
07ac 0a      LDN      Ra
07ad faf7    ANI      #f7
07af 5a      STR      Ra
07b0 f84b    LDI      #4b
07b2 ac      PLO      Rc
07b3 f836    LDI      #36              ; R8=2036
07b5 a8      PLO      R8
07b6 08      LDN      R8
07b7 ff30    SMI      #30
07b9 33c5    BDF      07c5
07bb 09      LDN      R9
07bc 32c5    BZ       07c5
07be 08      LDN      R8
07bf 32c9    BZ       07c9
07c1 f802    LDI      #02
07c3 30d6    BR       07d6

07c5  ;$07bc 07b9
07c5 f803    LDI      #03
07c7 30d6    BR       07d6

07c9  ;$07bf
07c9 f8ec    LDI      #ec              ; Ra=20ec
07cb aa      PLO      Ra
07cc 0a      LDN      Ra
07cd ff14    SMI      #14
07cf 33d4    BDF      07d4
07d1 f801    LDI      #01
07d3 c8      LSKP    
07d4  ;$07cf
07d4 f804    LDI      #04
07d6  ;$07c7 07c3
07d6 5c      STR      Rc
07d7 d40d67  CALL     0d67             ; Wlh[209c]=Wlh[20e5]+Wlh[20e3]
07da         DB       e3 e5 9c

07dd d40d67  CALL     0d67             ; Wlh[209c]=Wlh[20e5]+Wlh[209c]
07e0         DB       9c e5 9c

07e3 1c      INC      Rc
07e4 f805    LDI      #05
07e6 ad      PLO      Rd
07e7 f803    LDI      #03
07e9 af      PLO      Rf
07ea e2      SEX      R2
07eb 6c      INP      D4
07ec fa08    ANI      #08
07ee c2083d  LBZ      083d
07f1 f8e0    LDI      #e0              ; Ra=20e0
07f3 aa      PLO      Ra
07f4 0a      LDN      Ra
07f5 fbaa    XRI      #aa
07f7 ca0804  LBNZ     0804
07fa 6a      INP      D2
07fb fa30    ANI      #30
07fd f6      SHR     
07fe f6      SHR     
07ff f6      SHR     
0800 f6      SHR     
0801 bd      PHI      Rd
0802 3a07    BNZ      0807
0804  ;$07f7 
0804 1d      INC      Rd
0805 303d    BR       083d

0807  ;$0802
0807 2d      DEC      Rd
0808 f85d    LDI      #5d
080a ae      PLO      Re
080b f817    LDI      #17
080d be      PHI      Re               ; Re=175d
080e f89a    LDI      #9a              ; Rb=209a
0810 ab      PLO      Rb
0811 9d      GHI      Rd
0812 ff01    SMI      #01
0814 3228    BZ       0828
0816 ff01    SMI      #01
0818 321d    BZ       081d
081a f80c    LDI      #0c
081c c8      LSKP    
081d  ;$0818
081d f806    LDI      #06
081f 5b      STR      Rb
0820 eb      SEX      Rb
0821 8e      GLO      Re
0822 f4      ADD     
0823 ae      PLO      Re
0824 9e      GHI      Re
0825 7c00    ADCI     #00
0827 be      PHI      Re               ; Re+= 06  or  0c
0828  ;$083b 0814
0828 f89b    LDI      #9b              ; Rb=209b
082a ab      PLO      Rb
082b 4e      LDA      Re
082c 5b      STR      Rb
082d 2b      DEC      Rb               ; [209a]= Word from 175d table
082e 4e      LDA      Re
082f 5b      STR      Rb
0830 d40d77  CALL     0d77             ; Wlh[209a]=Wlh[209c]-Wlh[209a]
0833         DB       9c 9a 9a

0836 333d    BDF      083d
0838 2d      DEC      Rd
0839 2f      DEC      Rf
083a 8f      GLO      Rf
083b 3a28    BNZ      0828
083d  ;$0836 0805 07ee
083d 8d      GLO      Rd
083e 5c      STR      Rc
083f d5      RETN

0840  ;= zeroes upto 08ff

0900  ;= dial number from buffer 2060,  outputptr=2076, inputptr=2075
0900  ;*1603 152e 0b8c 0b5c 
0900 f806    LDI      #06              ; Rc=2006
0902 ac      PLO      Rc
0903 f896    LDI      #96              ; Rb=2096
0905 ab      PLO      Rb
0906 f891    LDI      #91              ; Ra=2091 : timeout counter
0908 aa      PLO      Ra
0909 f875    LDI      #75              ; R9=2075
090b a9      PLO      R9
090c f802    LDI      #02              ; R8=2002
090e a8      PLO      R8
090f 0b      LDN      Rb
0910 3213    BZ       0913
0912 a0      PLO      R0               ; jmp [Rb]

0913  ;$0910
0913 e9      SEX      R9
0914 72      LDXA    
0915 f7      SM                        ;   (check if digits available)
0916 32e3    BZ       09e3             ; if B[2075]==B[2076] re init
0918 2c      DEC      Rc
0919 0c      LDN      Rc
091a f902    ORI      #02
091c 5c      STR      Rc               ; B[2005]|=2
091d f846    LDI      #46
091f ac      PLO      Rc
0920 0c      LDN      Rc
0921 f6      SHR     
0922 3368    BDF      0968             ; if B[2046]&1 -> 0968 : dial dtmf
0924 49      LDA      R9
0925 a8      PLO      R8
0926 08      LDN      R8               ;   (get next digit)
0927 59      STR      R9               ; B[2077]=B[[2076]]
0928 f801    LDI      #01              ; next part after 1 clock tick
092a 5a      STR      Ra
092b  ;$0930
092b f82f    LDI      #2f
092d 5b      STR      Rb
092e d5      RETN    

092f 0a      LDN      Ra
0930 3a2b    BNZ      092b
0932  ;$0956
0932 1c      INC      Rc
0933 0c      LDN      Rc
0934 f908    ORI      #08              ; B[2007]|=8
0936 5c      STR      Rc
0937 f803    LDI      #03              ; next part after 3 clock ticks
0939 5a      STR      Ra
093a  ;$093f
093a f83e    LDI      #3e
093c 5b      STR      Rb
093d d5      RETN    

093e 0a      LDN      Ra
093f 3a3a    BNZ      093a

0941 1c      INC      Rc
0942 0c      LDN      Rc
0943 faf7    ANI      #f7
0945 5c      STR      Rc
0946 f802    LDI      #02              ; next part after 2 clock ticks
0948 5a      STR      Ra
0949  ;$094e
0949 f84d    LDI      #4d
094b 5b      STR      Rb
094c d5      RETN    

094d 0a      LDN      Ra
094e 3a49    BNZ      0949

0950 19      INC      R9
0951 19      INC      R9
0952 09      LDN      R9
0953 ff01    SMI      #01
0955 59      STR      R9
0956 3a32    BNZ      0932
0958 0c      LDN      Rc
0959 f902    ORI      #02
095b 5c      STR      Rc

095c f82d    LDI      #2d              ; next part after 2d clock ticks
095e 5a      STR      Ra
095f  ;$0964
095f f863    LDI      #63
0961 5b      STR      Rb
0962 d5      RETN    

0963 0a      LDN      Ra
0964 3a5f    BNZ      095f
0966 30d5    BR       09d5

0968  ;$0922
0968 28      DEC      R8
0969 08      LDN      R8
096a f902    ORI      #02              ; B[2001]|=2
096c 58      STR      R8
096d f802    LDI      #02              ; next part after 2 clock ticks
096f 5a      STR      Ra
0970  ;$0975
0970 f874    LDI      #74
0972 5b      STR      Rb
0973 d5      RETN    

0974 0a      LDN      Ra
0975 3a70    BNZ      0970
0977 18      INC      R8
0978 08      LDN      R8
0979 f908    ORI      #08              ; B[2003]|=8
097b 58      STR      R8
097c f802    LDI      #02              ; next part after 2 clock ticks
097e 5a      STR      Ra
097f  ;$0984
097f f883    LDI      #83
0981 5b      STR      Rb
0982 d5      RETN    

0983 0a      LDN      Ra
0984 3a7f    BNZ      097f
0986 19      INC      R9
0987 09      LDN      R9
0988 a8      PLO      R8               ; R8=[2076]
0989 e8      SEX      R8
098a f83d    LDI      #3d
098c f4      ADD     
098d ad      PLO      Rd
098e f817    LDI      #17
0990 7c00    ADCI     #00
0992 bd      PHI      Rd               ; Rd=173d+B[[2076]]
0993 8d      GLO      Rd
0994 f4      ADD     
0995 ad      PLO      Rd
0996 9d      GHI      Rd
0997 7c00    ADCI     #00
0999 bd      PHI      Rd               ; Rd+=B[[2076]]
099a 2d      DEC      Rd
099b 2d      DEC      Rd
099c ed      SEX      Rd               ; Rd=173b+2*B[[2076]]
099d f801    LDI      #01
099f a8      PLO      R8               ; R8=2001

09a0 88      GLO      R8
09a1 f4      ADD     
09a2 a9      PLO      R9               ; R9=2001+[Rd]
09a3 09      LDN      R9
09a4 fafe    ANI      #fe
09a6 59      STR      R9               ; [2001+[Rd]]&=fe

09a7 1d      INC      Rd
09a8 88      GLO      R8
09a9 f4      ADD     
09aa a9      PLO      R9
09ab 09      LDN      R9
09ac fafe    ANI      #fe
09ae 59      STR      R9               ; [2001+[Rd+1]]&=fe

09af f805    LDI      #05              ; next part after 5 clock ticks
09b1 5a      STR      Ra
09b2  ;$09b7
09b2 f8b6    LDI      #b6
09b4 5b      STR      Rb
09b5 d5      RETN    

09b6 0a      LDN      Ra
09b7 3ab2    BNZ      09b2

09b9 0c      LDN      Rc
09ba f902    ORI      #02
09bc 5c      STR      Rc
09bd 08      LDN      R8
09be f902    ORI      #02
09c0 58      STR      R8
09c1 18      INC      R8
09c2 08      LDN      R8
09c3 fa07    ANI      #07
09c5 58      STR      R8

09c6 f808    LDI      #08
09c8 af      PLO      Rf
09c9 f808    LDI      #08              ; R8=2008
09cb a8      PLO      R8
09cc e8      SEX      R8
09cd  ;$09d3
09cd 08      LDN      R8
09ce f901    ORI      #01
09d0 73      STXD    
09d1 2f      DEC      Rf
09d2 8f      GLO      Rf
09d3 3acd    BNZ      09cd

09d5  ;$0966
09d5 19      INC      R9
09d6 09      LDN      R9
09d7 fb60    XRI      #60
09d9 3adf    BNZ      09df
09db f874    LDI      #74
09dd 30e2    BR       09e2

09df  ;$09d9
09df 09      LDN      R9
09e0 ff01    SMI      #01
09e2  ;$09dd
09e2 59      STR      R9
09e3  ;$0916
09e3 f800    LDI      #00
09e5 5b      STR      Rb
09e6 d5      RETN    

09e7  ;=compute ROM sum 0000-17ff
09e7  ;*0731
09e7 f800    LDI      #00
09e9 ae      PLO      Re
09ea af      PLO      Rf
09eb f818    LDI      #18
09ed bf      PHI      Rf               ; Rf=1800
09ee ef      SEX      Rf
09ef  ;$09f7 09f4
09ef 2f      DEC      Rf
09f0 8e      GLO      Re
09f1 f4      ADD                       ; Re+=B[Rf--]
09f2 ae      PLO      Re
09f3 8f      GLO      Rf
09f4 3aef    BNZ      09ef
09f6 9f      GHI      Rf
09f7 3aef    BNZ      09ef
09f9 d5      RETN

    
09fa  ;= zeroes upto 09ff

0a00  ;=go through 4 different subrs (addr in 2037)
0a00  ;*13ab 0ba8 0b73 
0a00 f837    LDI      #37              ; Rb=2037
0a02 ab      PLO      Rb
0a03 f890    LDI      #90              ; Ra=2090
0a05 aa      PLO      Ra
0a06 f838    LDI      #38              ; R9=2038
0a08 a9      PLO      R9
0a09 f83a    LDI      #3a              ; R8=203a
0a0b a8      PLO      R8
0a0c 0b      LDN      Rb
0a0d 3210    BZ       0a10
0a0f a0      PLO      R0               ; jmp [Rb]

0a10  ;$0a0d
0a10 e2      SEX      R2
0a11 6a      INP      D2
0a12 fbff    XRI      #ff
0a14 e9      SEX      R9
0a15 f2      AND     
0a16 19      INC      R9
0a17 f6      SHR     
0a18 3324    BDF      0a24
0a1a 3a1d    BNZ      0a1d
0a1c d5      RETN    

0a1d  ;$0a1a
0a1d f804    LDI      #04
0a1f 59      STR      R9
0a20 f801    LDI      #01
0a22 302b    BR       0a2b

0a24  ;$0a18
0a24 3aea    BNZ      0aea
0a26 f801    LDI      #01
0a28 59      STR      R9
0a29 f800    LDI      #00
0a2b  ;$0a22
0a2b 58      STR      R8
0a2c f814    LDI      #14
0a2e 5a      STR      Ra
0a2f  ;$0a3c
0a2f e2      SEX      R2
0a30 6a      INP      D2
0a31 fbff    XRI      #ff
0a33 e9      SEX      R9
0a34 f2      AND     
0a35 3240    BZ       0a40
0a37 f83b    LDI      #3b
0a39 5b      STR      Rb
0a3a d5      RETN    

0a3b 0a      LDN      Ra
0a3c 3a2f    BNZ      0a2f
0a3e 30ea    BR       0aea

0a40  ;$0a55 0a35
0a40 f839    LDI      #39              ; R9=2039
0a42 a9      PLO      R9
0a43 e2      SEX      R2
0a44 6a      INP      D2
0a45 fbff    XRI      #ff
0a47 af      PLO      Rf
0a48 e9      SEX      R9
0a49 f2      AND     
0a4a 3aea    BNZ      0aea
0a4c 8f      GLO      Rf
0a4d fe      SHL     
0a4e 3359    BDF      0a59
0a50 f854    LDI      #54
0a52 5b      STR      Rb
0a53 d5      RETN    

0a54 0a      LDN      Ra
0a55 3a40    BNZ      0a40
0a57 30ea    BR       0aea

0a59  ;$0a4e
0a59 e2      SEX      R2
0a5a 6a      INP      D2
0a5b fbff    XRI      #ff
0a5d f6      SHR     
0a5e e9      SEX      R9
0a5f f2      AND     
0a60 3aea    BNZ      0aea
0a62 f814    LDI      #14
0a64 5a      STR      Ra
0a65 f804    LDI      #04
0a67 ac      PLO      Rc
0a68 0c      LDN      Rc
0a69 f908    ORI      #08
0a6b 5c      STR      Rc
0a6c 08      LDN      R8
0a6d f6      SHR     
0a6e 3b71    BNF      0a71
0a70 2c      DEC      Rc
0a71  ;$0a6e
0a71 0c      LDN      Rc
0a72 f904    ORI      #04
0a74 5c      STR      Rc
0a75  ;$0a9a 0a91
0a75 f879    LDI      #79
0a77 5b      STR      Rb
0a78 d5      RETN    

0a79 19      INC      R9
0a7a e2      SEX      R2
0a7b 6a      INP      D2
0a7c fbff    XRI      #ff
0a7e af      PLO      Rf
0a7f e9      SEX      R9
0a80 f2      AND     
0a81 3287    BZ       0a87
0a83 18      INC      R8
0a84 88      GLO      R8
0a85 58      STR      R8
0a86 28      DEC      R8
0a87  ;$0a81
0a87 8f      GLO      Rf
0a88 f6      SHR     
0a89 f2      AND     
0a8a 3aa3    BNZ      0aa3
0a8c 0a      LDN      Ra
0a8d 32ea    BZ       0aea
0a8f ff13    SMI      #13
0a91 3375    BDF      0a75
0a93 f804    LDI      #04
0a95 ac      PLO      Rc
0a96 0c      LDN      Rc
0a97 faf7    ANI      #f7
0a99 5c      STR      Rc
0a9a 3075    BR       0a75

0a9c  ;$0b1d 
0a9c f8a0    LDI      #a0
0a9e 5b      STR      Rb
0a9f d5      RETN    

0aa0 c00b11  LBR      0b11

0aa3  ;$0a8a
0aa3 f800    LDI      #00
0aa5 5a      STR      Ra
0aa6 e8      SEX      R8
0aa7 f81d    LDI      #1d
0aa9 f7      SM      
0aaa ac      PLO      Rc
0aab f80d    LDI      #0d
0aad f7      SM      
0aae a9      PLO      R9
0aaf 09      LDN      R9
0ab0 fc01    ADI      #01
0ab2 59      STR      R9
0ab3 ec      SEX      Rc
0ab4 f7      SM      
0ab5 3bc7    BNF      0ac7
0ab7 f83c    LDI      #3c
0ab9 ac      PLO      Rc
0aba 08      LDN      R8
0abb 3ac0    BNZ      0ac0
0abd f880    LDI      #80
0abf c8      LSKP    
0ac0  ;$0abb
0ac0 f801    LDI      #01
0ac2 f1      OR      
0ac3 5c      STR      Rc
0ac4 f80f    LDI      #0f
0ac6 5a      STR      Ra
0ac7  ;$0ab5
0ac7 e8      SEX      R8
0ac8 f818    LDI      #18
0aca f4      ADD     
0acb f4      ADD     
0acc a9      PLO      R9
0acd f89a    LDI      #9a              ; R8=209a
0acf a8      PLO      R8
0ad0 49      LDA      R9
0ad1 58      STR      R8
0ad2 18      INC      R8
0ad3 09      LDN      R9
0ad4 58      STR      R8
0ad5 d40d67  CALL     0d67             ; Wlh[201e]=Wlh[209a]+Wlh[201e]
0ad8         DB       9a 1e 1e

0adb f890    LDI      #90              ; Ra=2090
0add aa      PLO      Ra
0ade f838    LDI      #38              ; R9=2038
0ae0 a9      PLO      R9
0ae1 f848    LDI      #48              ; R8=2048
0ae3 a8      PLO      R8
0ae4 08      LDN      R8
0ae5 f901    ORI      #01
0ae7 58      STR      R8
0ae8 30ee    BR       0aee

0aea  ;$0a8d 0a60 0a57 0a4a 0a3e 0a24
0aea f83b    LDI      #3b              ; R8=203b
0aec a8      PLO      R8
0aed 58      STR      R8
0aee  ;$0ae8
0aee f805    LDI      #05              ; R8=2005
0af0 a8      PLO      R8
0af1 e8      SEX      R8
0af2 08      LDN      R8
0af3 f908    ORI      #08
0af5 73      STXD    
0af6 08      LDN      R8
0af7 faf3    ANI      #f3
0af9 73      STXD    
0afa 08      LDN      R8
0afb fafb    ANI      #fb
0afd 58      STR      R8
0afe e0      SEX      R0
0aff 71      DIS                       ; set X=8, P=0
0b00 80      DB       80

0b01 f801    LDI      #01              ; R8=2001
0b03 a8      PLO      R8
0b04 61      OUT      D1
0b05 61      OUT      D1
0b06 61      OUT      D1
0b07 61      OUT      D1
0b08 61      OUT      D1
0b09 61      OUT      D1
0b0a 61      OUT      D1
0b0b 61      OUT      D1
0b0c 63      OUT      D3
0b0d 64      OUT      D4
0b0e e0      SEX      R0
0b0f 70      RET                       ; set X=8, P=0
0b10 80      DB       80

0b11  ;$0aa0 
0b11 f83b    LDI      #3b              ; R8=203b
0b13 a8      PLO      R8
0b14 08      LDN      R8
0b15 3220    BZ       0b20
0b17 f800    LDI      #00
0b19 58      STR      R8
0b1a  ;$0b2a
0b1a f819    LDI      #19
0b1c 5a      STR      Ra
0b1d  ;$0b2c
0b1d c00a9c  LBR      0a9c

0b20  ;$0b15
0b20 0a      LDN      Ra
0b21 322e    BZ       0b2e
0b23 e2      SEX      R2
0b24 6a      INP      D2
0b25 fbff    XRI      #ff
0b27 19      INC      R9
0b28 e9      SEX      R9
0b29 f2      AND     
0b2a 3a1a    BNZ      0b1a
0b2c 301d    BR       0b1d

0b2e  ;$0b21
0b2e e8      SEX      R8
0b2f f800    LDI      #00
0b31 73      STXD    
0b32 73      STXD    
0b33 73      STXD    
0b34 28      DEC      R8
0b35 73      STXD    
0b36 f805    LDI      #05
0b38 ac      PLO      Rc
0b39 0c      LDN      Rc
0b3a faf7    ANI      #f7
0b3c 5c      STR      Rc
0b3d e0      SEX      R0
0b3e 71      DIS
0b3f 80      DB       80               ; set X=8, P=0

0b40 f801    LDI      #01              ; R8=2001
0b42 a8      PLO      R8
0b43 61      OUT      D1
0b44 61      OUT      D1
0b45 61      OUT      D1
0b46 61      OUT      D1
0b47 61      OUT      D1
0b48 61      OUT      D1
0b49 61      OUT      D1
0b4a 61      OUT      D1
0b4b 64      OUT      D4
0b4c e0      SEX      R0
0b4d 70      RET
0b4e 80      DB       80               ; set X=8, P=0

0b4f d5      RETN    

0b50  ;*12a8 1241
0b50 f895    LDI      #95
0b52 a7      PLO      R7               ; R7=2095
0b53 f800    LDI      #00
0b55 57      STR      R7               ; B[2095]=0
0b56 f896    LDI      #96
0b58 a8      PLO      R8               ; R8=2096
0b59 08      LDN      R8
0b5a 3262    BZ       0b62
0b5c d40900  CALL     0900             ; dial number
0b5f f801    LDI      #01
0b61 57      STR      R7
0b62  ;$0b5a
0b62 f83d    LDI      #3d              ; R8=203d
0b64 a8      PLO      R8
0b65 08      LDN      R8
0b66 326d    BZ       0b6d
0b68 d40c00  CALL     0c00
0b6b 3076    BR       0b76

0b6d  ;$0b66
0b6d f837    LDI      #37              ; R8=2037
0b6f a8      PLO      R8
0b70 08      LDN      R8
0b71 327a    BZ       0b7a
0b73 d40a00  CALL     0a00
0b76  ;$0b6b
0b76 07      LDN      R7
0b77 f980    ORI      #80
0b79 57      STR      R7
0b7a  ;$0b71
0b7a f884    LDI      #84              ; R8=2084
0b7c a8      PLO      R8
0b7d 08      LDN      R8
0b7e 3ab4    BNZ      0bb4
0b80 07      LDN      R7
0b81 f6      SHR     
0b82 338f    BDF      0b8f
0b84 f875    LDI      #75              ; R8=2075
0b86 a8      PLO      R8
0b87 e8      SEX      R8
0b88 72      LDXA    
0b89 f3      XOR     
0b8a 328f    BZ       0b8f
0b8c d40900  CALL     0900             ; dial number
0b8f  ;$0b8a 0b82
0b8f 07      LDN      R7
0b90 fe      SHL     
0b91 33ab    BDF      0bab
0b93 f83c    LDI      #3c              ; R8=203c
0b95 a8      PLO      R8
0b96 08      LDN      R8
0b97 32a2    BZ       0ba2
0b99 d40c00  CALL     0c00
0b9c f83d    LDI      #3d              ; R8=203d
0b9e a8      PLO      R8
0b9f 08      LDN      R8
0ba0 3aab    BNZ      0bab
0ba2  ;$0b97
0ba2 e2      SEX      R2
0ba3 6a      INP      D2
0ba4 fa05    ANI      #05
0ba6 32ab    BZ       0bab
0ba8 d40a00  CALL     0a00
0bab  ;$0ba6 0ba0 0b91
0bab f848    LDI      #48              ; R8=2048
0bad a8      PLO      R8
0bae 08      LDN      R8
0baf f6      SHR     
0bb0 3bf9    BNF      0bf9
0bb2 30d5    BR       0bd5

0bb4  ;$0b7e
0bb4 ff01    SMI      #01
0bb6 58      STR      R8
0bb7 18      INC      R8
0bb8 08      LDN      R8
0bb9 ff02    SMI      #02
0bbb 33c9    BDF      0bc9
0bbd d40d77  CALL     0d77             ; Wlh[201e]=Wlh[201e]-Wlh[2016]
0bc0         DB       1e 16 1e

0bc3 d40d67  CALL     0d67             ; Wlh[204e]=Wlh[204e]+Wlh[2016]
0bc6         DB       4e 16 4e

0bc9  ;$0bbb
0bc9 d40d77  CALL     0d77             ; Wlh[201e]=Wlh[201e]-Wlh[2014]
0bcc         DB       1e 14 1e

0bcf d40d67  CALL     0d67             ; Wlh[204e]=Wlh[204e]+Wlh[2014]
0bd2         DB       4e 14 4e

0bd5  ;$0bb2
0bd5 d40e61  CALL     0e61
0bd8 f848    LDI      #48              ; R8=2048
0bda a8      PLO      R8
0bdb 08      LDN      R8
0bdc fafe    ANI      #fe
0bde 58      STR      R8
0bdf f81f    LDI      #1f              ; R8=201f
0be1 a8      PLO      R8
0be2 08      LDN      R8
0be3 fe      SHL     
0be4 33ed    BDF      0bed
0be6 d40d91  CALL     0d91             ; convert Wlh[201e] -> BCD buf[209a]
0be9         DB       1e 9a

0beb 30f5    BR       0bf5

0bed  ;$0be4
0bed f89b    LDI      #9b              ; R9=209b
0bef a9      PLO      R9
0bf0 f800    LDI      #00
0bf2 59      STR      R9
0bf3 29      DEC      R9
0bf4 59      STR      R9
0bf5  ;$0beb
0bf5 d40dda  CALL     0dda
0bf8         DB       9a

0bf9  ;$0bb0
0bf9 d5      RETN

0bfa  ;= zeroes upto 0bff

0c00  ;=go through different subrs (addr in 203d)
0c00  ;*13b0 0b99 0b68 
0c00 f83d    LDI      #3d              ; R8=203d
0c02 a8      PLO      R8
0c03 f88f    LDI      #8f              ; Rb=208f
0c05 ab      PLO      Rb
0c06 48      LDA      R8
0c07 3211    BZ       0c11
0c09 08      LDN      R8
0c0a fe      SHL     
0c0b cb0d23  LBNF     0d23
0c0e 28      DEC      R8
0c0f 08      LDN      R8
0c10 a0      PLO      R0               ; jmp [r8]

0c11  ;$0c07
0c11 f880    LDI      #80
0c13 ad      PLO      Rd
0c14 58      STR      R8
0c15 28      DEC      R8
0c16 28      DEC      R8
0c17 f84e    LDI      #4e              ; R9=204e
0c19 a9      PLO      R9
0c1a f818    LDI      #18              ; Ra=2018
0c1c aa      PLO      Ra
0c1d f806    LDI      #06
0c1f ac      PLO      Rc
0c20 ea      SEX      Ra
0c21 08      LDN      R8
0c22 fe      SHL     
0c23 3b2c    BNF      0c2c
0c25 f6      SHR     
0c26 af      PLO      Rf
0c27 f80d    LDI      #0d              ; R8=200d
0c29 a8      PLO      R8
0c2a 3039    BR       0c39

0c2c  ;$0c23
0c2c f6      SHR     
0c2d f6      SHR     
0c2e cb0d23  LBNF     0d23
0c31 fe      SHL     
0c32 af      PLO      Rf
0c33 f80c    LDI      #0c              ; R8=200c
0c35 a8      PLO      R8
0c36 2c      DEC      Rc
0c37 1a      INC      Ra
0c38 1a      INC      Ra
0c39  ;$0c2a
0c39 49      LDA      R9
0c3a f7      SM      
0c3b ae      PLO      Re
0c3c 09      LDN      R9
0c3d 1a      INC      Ra
0c3e 77      SMB     
0c3f be      PHI      Re
0c40 cb0d23  LBNF     0d23
0c43 e9      SEX      R9
0c44 9e      GHI      Re
0c45 73      STXD    
0c46 8e      GLO      Re
0c47 59      STR      R9
0c48 f83c    LDI      #3c              ; R9=203c
0c4a a9      PLO      R9
0c4b 8f      GLO      Rf
0c4c 59      STR      R9
0c4d f83e    LDI      #3e              ; R9=203e
0c4f a9      PLO      R9
0c50 307f    BR       0c7f


0c52  ;=subr, 2 params
0c52  ;*14a1 1498 
0c52 f83d    LDI      #3d
0c54 a8      PLO      R8               ; R8=203d
0c55 f88f    LDI      #8f
0c57 ab      PLO      Rb               ; Rb=208f
0c58 48      LDA      R8
0c59 3265    BZ       0c65             ; if *R8++
0c5b 08      LDN      R8               ; if *R8&0x80 -> exit
0c5c fe      SHL
0c5d c30d23  LBDF     0d23
0c60 13      INC      R3               ; skip 2 bytes
0c61 13      INC      R3
0c62 28      DEC      R8
0c63 08      LDN      R8
0c64 a0      PLO      R0               ; jmp [--r8]

0c65  ;$0c59
0c65 88      GLO      R8
0c66 a9      PLO      R9               ; R9=R8
0c67 18      INC      R8
0c68 43      LDA      R3
0c69 58      STR      R8               ; *++R8=*R3++ (param 1)
0c6a a8      PLO      R8               ; R8=data
0c6b 43      LDA      R3
0c6c 59      STR      R9               ; *R9=*R3++  (param 2)
0c6d  ;$0d1a
0c6d f800    LDI      #00
0c6f ad      PLO      Rd
0c70 f805    LDI      #05
0c72 ac      PLO      Rc
0c73 e8      SEX      R8
0c74 72      LDXA    
0c75 f1      OR      
0c76 28      DEC      R8
0c77 3a7f    BNZ      0c7f
0c79 f83f    LDI      #3f              ; R8=203f
0c7b a8      PLO      R8
0c7c c00d1d  LBR      0d1d

0c7f  ;$0cc7 0c77 0c50
0c7f 08      LDN      R8
0c80 32c1    BZ       0cc1
0c82 ff01    SMI      #01
0c84 58      STR      R8
0c85 0c      LDN      Rc
0c86 f904    ORI      #04
0c88 5c      STR      Rc
0c89 8c      GLO      Rc
0c8a bf      PHI      Rf
0c8b f804    LDI      #04
0c8d ac      PLO      Rc
0c8e 0c      LDN      Rc
0c8f f908    ORI      #08
0c91 5c      STR      Rc
0c92 9f      GHI      Rf
0c93 ac      PLO      Rc
0c94 09      LDN      R9
0c95 f6      SHR     
0c96 3ba6    BNF      0ca6
0c98 8c      GLO      Rc
0c99 ff04    SMI      #04
0c9b ac      PLO      Rc
0c9c 0c      LDN      Rc
0c9d f904    ORI      #04
0c9f 5c      STR      Rc
0ca0 8c      GLO      Rc
0ca1 fc04    ADI      #04
0ca3 ac      PLO      Rc
0ca4 30c1    BR       0cc1

0ca6  ;$0c96
0ca6 88      GLO      R8
0ca7 fb0c    XRI      #0c
0ca9 32b5    BZ       0cb5
0cab 88      GLO      R8
0cac fb0e    XRI      #0e
0cae 32b5    BZ       0cb5
0cb0 f8e3    LDI      #e3              ; Ra=20e3
0cb2 aa      PLO      Ra
0cb3 30b8    BR       0cb8

0cb5  ;$0cae 0ca9
0cb5 f8e5    LDI      #e5              ; Ra=20e5
0cb7 aa      PLO      Ra
0cb8  ;$0cb3
0cb8 0a      LDN      Ra
0cb9 fc01    ADI      #01
0cbb 5a      STR      Ra
0cbc 1a      INC      Ra
0cbd 0a      LDN      Ra
0cbe 7c00    ADCI     #00
0cc0 5a      STR      Ra
0cc1  ;$0ca4 0c80
0cc1 8d      GLO      Rd
0cc2 3ac9    BNZ      0cc9
0cc4 1d      INC      Rd
0cc5 18      INC      R8
0cc6 1c      INC      Rc
0cc7 307f    BR       0c7f

0cc9  ;$0cc2
0cc9 f80a    LDI      #0a
0ccb 5b      STR      Rb
0ccc f83d    LDI      #3d              ; R8=203d
0cce a8      PLO      R8
0ccf  ;$0cf2 0ce5
0ccf f8d3    LDI      #d3
0cd1 58      STR      R8
0cd2 d5      RETN    

0cd3 0b      LDN      Rb               ; ?unreferenced?
0cd4 ec      SEX      Rc
0cd5 32fc    BZ       0cfc
0cd7 ff09    SMI      #09
0cd9 33e2    BDF      0ce2
0cdb f804    LDI      #04
0cdd ac      PLO      Rc
0cde 0c      LDN      Rc
0cdf faf7    ANI      #f7
0ce1 5c      STR      Rc
0ce2  ;$0cd9
0ce2 0b      LDN      Rb
0ce3 fb06    XRI      #06
0ce5 3acf    BNZ      0ccf
0ce7 f806    LDI      #06
0ce9 ac      PLO      Rc
0cea f80b    LDI      #0b
0cec f2      AND     
0ced 73      STXD    
0cee f80b    LDI      #0b
0cf0 f2      AND     
0cf1 5c      STR      Rc
0cf2 30cf    BR       0ccf

0cf4  ;$0d0a 
0cf4 f8f8    LDI      #f8
0cf6 58      STR      R8
0cf7 d5      RETN    

0cf8 0b      LDN      Rb               ; ?unreferenced?
0cf9 c00d0d  LBR      0d0d

0cfc  ;$0cd5
0cfc f802    LDI      #02
0cfe ac      PLO      Rc
0cff f80b    LDI      #0b
0d01 f2      AND     
0d02 73      STXD    
0d03 f80b    LDI      #0b
0d05 f2      AND     
0d06 73      STXD    
0d07 f805    LDI      #05
0d09 5b      STR      Rb
0d0a  ;$0d0d
0d0a c00cf4  LBR      0cf4

0d0d  ;$0cf9 
0d0d 3a0a    BNZ      0d0a
0d0f f83e    LDI      #3e              ; R9=203e
0d11 a9      PLO      R9
0d12 a8      PLO      R8               ; R8=203e
0d13 18      INC      R8
0d14 09      LDN      R9
0d15 fe      SHL     
0d16 331d    BDF      0d1d
0d18 08      LDN      R8
0d19 a8      PLO      R8
0d1a c00c6d  LBR      0c6d

0d1d  ;$0d16 0c7c
0d1d e8      SEX      R8
0d1e f800    LDI      #00
0d20 73      STXD    
0d21 73      STXD    
0d22 58      STR      R8
0d23  ;$0c5d 0c40 0c2e 0c0b 
0d23 d5      RETN    

0d24  ;=subr, 4 params : multiply Wlh[par3]=B[par2]*Wlh[par1]
0d24  ;*1192 10e9 10df 10c5 0f71 0e07 
0d24 43      LDA      R3
0d25 a8      PLO      R8               ; R8=par1
0d26 43      LDA      R3
0d27 a9      PLO      R9               ; R9=par2
0d28 43      LDA      R3
0d29 aa      PLO      Ra               ; Ra=par3
0d2a ea      SEX      Ra
0d2b 48      LDA      R8
0d2c ae      PLO      Re
0d2d 08      LDN      R8               ; Re=W[r8]
0d2e be      PHI      Re

0d2f 43      LDA      R3
0d30 3a33    BNZ      0d33
0d32 be      PHI      Re               ; if (par4==0)  Re.1=0
0d33  ;$0d30
0d33 09      LDN      R9
0d34 ad      PLO      Rd               ; Rd=B[r9]
0d35 f800    LDI      #00
0d37 5a      STR      Ra               ; W[Ra]=0
0d38 1a      INC      Ra
0d39 73      STXD    
0d3a  ;$0d58
0d3a fc00    ADI      #00              ;  clear carryflag
0d3c 8d      GLO      Rd               ; Rd>>=1
0d3d 3251    BZ       0d51
0d3f f6      SHR     
0d40 ad      PLO      Rd
0d41 3b52    BNF      0d52
0d43 8e      GLO      Re               ; W[Ra]+=Re
0d44 f4      ADD
0d45 5a      STR      Ra
0d46 1a      INC      Ra
0d47 9e      GHI      Re
0d48 74      ADC     
0d49 73      STXD    
0d4a 3b52    BNF      0d52
0d4c f8ff    LDI      #ff
0d4e 5a      STR      Ra
0d4f 1a      INC      Ra
0d50 73      STXD    
0d51  ;$0d3d
0d51 d5      RETN    

0d52  ;$0d4a 0d41
0d52 8e      GLO      Re               ; Re<<=1
0d53 fe      SHL     
0d54 ae      PLO      Re
0d55 9e      GHI      Re
0d56 7e      SHLC    
0d57 be      PHI      Re
0d58 303a    BR       0d3a


0d5a  ;=subr, 2 params : clear [2] bytes upto mem  20[1]
0d5a  ;*11a7 107d 
0d5a 43      LDA      R3
0d5b a8      PLO      R8
0d5c 43      LDA      R3
0d5d ae      PLO      Re
0d5e e8      SEX      R8
0d5f  ;$0d64
0d5f f800    LDI      #00
0d61 73      STXD    
0d62 2e      DEC      Re
0d63 8e      GLO      Re
0d64 3a5f    BNZ      0d5f
0d66 d5      RETN    

0d67  ;=subr, 3 params  W20[3]:=W20[1]+W20[2]
0d67  ;*15a9 15a3 13dd 13d1 10d6 0bcf 0bc3 0ad5 07dd 07d7 
0d67 43      LDA      R3
0d68 a8      PLO      R8
0d69 43      LDA      R3
0d6a a9      PLO      R9
0d6b 43      LDA      R3
0d6c aa      PLO      Ra
0d6d e8      SEX      R8
0d6e 49      LDA      R9
0d6f f4      ADD     
0d70 5a      STR      Ra
0d71 18      INC      R8
0d72 1a      INC      Ra
0d73 09      LDN      R9
0d74 74      ADC     
0d75 5a      STR      Ra
0d76 d5      RETN
    
0d77  ;=subr, 3 params   Wlh[3]:=Wlh[1]-Wlh[2]
0d77  ;*13d7 13cb 1341 125e 0e31 0e26 0e1e 0e16 0e0e 0dfc 0bc9 0bbd 0830 
0d77 43      LDA      R3
0d78 a8      PLO      R8
0d79 43      LDA      R3
0d7a a9      PLO      R9
0d7b 43      LDA      R3
0d7c aa      PLO      Ra
0d7d e9      SEX      R9
0d7e 48      LDA      R8
0d7f f7      SM      
0d80 5a      STR      Ra
0d81 19      INC      R9
0d82 1a      INC      Ra
0d83 08      LDN      R8
0d84 77      SMB     
0d85 5a      STR      Ra
0d86 d5      RETN    

0d87  ;=subr, 1 param   Q=1, what [1] timerirq's
0d87  ;*1646 1634 161c 160d 15fc 15e0 10f9 108b 05d9 
0d87 f88e    LDI      #8e              ; R9=208e
0d89 a9      PLO      R9
0d8a 43      LDA      R3
0d8b 59      STR      R9
0d8c  ;$0d8e
0d8c 7b      SEQ                       ; keep 1 high, it is automaticly reset
0d8d 09      LDN      R9               ; by the interrupt routine
0d8e 3a8c    BNZ      0d8c
0d90 d5      RETN    

0d91  ;=subr, 2 params : convert Wlh[par1] -> BCD[par2] (3 bytes)
0d91  ;*15c0 0be6 05f0 05cd 
0d91 43      LDA      R3
0d92 a8      PLO      R8               ; R8=par1
0d93 43      LDA      R3
0d94 a9      PLO      R9               ; R9=par2
0d95 f804    LDI      #04
0d97 af      PLO      Rf               ; Rf=4
0d98 48      LDA      R8
0d99 ae      PLO      Re
0d9a 08      LDN      R8
0d9b be      PHI      Re               ; Re=Wlh[par1]
0d9c f800    LDI      #00
0d9e 59      STR      R9
0d9f 19      INC      R9
0da0 59      STR      R9
0da1 19      INC      R9
0da2 59      STR      R9               ; 3B[par2]=0
0da3 f855    LDI      #55
0da5 ad      PLO      Rd
0da6 f817    LDI      #17
0da8 bd      PHI      Rd               ; Rd=1755
0da9 ed      SEX      Rd

0daa  ;$0dd0 0dbf
0daa 8e      GLO      Re
0dab f7      SM      
0dac ae      PLO      Re
0dad 1d      INC      Rd
0dae 9e      GHI      Re
0daf 77      SMB     
0db0 be      PHI      Re
0db1 2d      DEC      Rd               ; Re-=Wlh[Rd]
0db2 3bc1    BNF      0dc1

0db4 8f      GLO      Rf               ; Rf=digit nr (even : lownyble)
0db5 f6      SHR
0db6 09      LDN      R9
0db7 33bc    BDF      0dbc
0db9 fc01    ADI      #01              ; inc low nyble
0dbb c8      LSKP    
0dbc  ;$0db7
0dbc fc10    ADI      #10              ; inc high nyble
0dbe 59      STR      R9
0dbf 30aa    BR       0daa

0dc1  ;$0db2                           ; skip to next digit
0dc1 8e      GLO      Re
0dc2 f4      ADD     
0dc3 ae      PLO      Re
0dc4 1d      INC      Rd
0dc5 9e      GHI      Re
0dc6 74      ADC     
0dc7 be      PHI      Re               ; Re+=Wlh[Rd]

0dc8 8f      GLO      Rf
0dc9 f6      SHR     
0dca 33cd    BDF      0dcd             ; if even digit : skip to next byte
0dcc 29      DEC      R9
0dcd  ;$0dca
0dcd 1d      INC      Rd
0dce 2f      DEC      Rf
0dcf 8f      GLO      Rf
0dd0 3aaa    BNZ      0daa
0dd2 8e      GLO      Re               ; put units in number
0dd3 e9      SEX      R9
0dd4 f1      OR      
0dd5 59      STR      R9
0dd6 d5      RETN    

0dd7  ;=subr, 1 param
0dd7  ;*15c5 158e 05dd 
0dd7 f801    LDI      #01
0dd9 c8      LSKP    

0dda  ;=subr, 1 param
0dda  ;*0bf5 
0dda f800    LDI      #00
0ddc af      PLO      Rf
0ddd 43      LDA      R3
0dde a9      PLO      R9
0ddf 19      INC      R9
0de0 f80a    LDI      #0a              ; R8=200a
0de2 a8      PLO      R8
0de3 e8      SEX      R8
0de4 09      LDN      R9
0de5 faf0    ANI      #f0
0de7 3af6    BNZ      0df6
0de9 09      LDN      R9
0dea 32f0    BZ       0df0
0dec f9f0    ORI      #f0
0dee 30f7    BR       0df7

0df0  ;$0dea
0df0 8f      GLO      Rf
0df1 3af6    BNZ      0df6
0df3 f8ff    LDI      #ff
0df5 38      SKP     
0df6  ;$0df1 0de7
0df6 09      LDN      R9
0df7  ;$0dee
0df7 73      STXD    
0df8 29      DEC      R9
0df9 09      LDN      R9
0dfa 58      STR      R8
0dfb d5      RETN
    
0dfc  ;$0e41 
0dfc  ;*1491 
0dfc d40d77  CALL     0d77             ; Wlh[209c]=Wlh[201e]-Wlh[2018]
0dff         DB       1e 18 9c

0e02 3b44    BNF      0e44
0e04 f801    LDI      #01
0e06 af      PLO      Rf
0e07 d40d24  CALL     0d24             ; Wlh[209a]=B[200d]*B[2018]
0e0a 18      DB       18 0d 9a 00

0e0e d40d77  CALL     0d77             ; Wlh[209c]=Wlh[209a]-Wlh[201e]
0e11         DB       9a 1e 9c

0e14 3326    BDF      0e26
0e16 d40d77  CALL     0d77             ; Wlh[209c]=Wlh[201e]-Wlh[201a]
0e19         DB       1e 1a 9c

0e1c 3331    BDF      0e31
0e1e d40d77  CALL     0d77             ; Wlh[209c]=Wlh[209a]-Wlh[2018]
0e21         DB       9a 18 9c

0e24 3b44    BNF      0e44
0e26  ;$0e14
0e26 d40d77  CALL     0d77             ; Wlh[201e]=Wlh[201e]-Wlh[2018]
0e29         DB       1e 18 1e

0e2c f80f    LDI      #0f              ; R9=200f
0e2e a9      PLO      R9
0e2f 303a    BR       0e3a

0e31  ;$0e1c
0e31 d40d77  CALL     0d77             ; Wlh[201e]=Wlh[201e]-Wlh[201a]
0e34         DB       1e 1a 1e

0e37 f80e    LDI      #0e              ; R9=200e
0e39 a9      PLO      R9
0e3a  ;$0e2f
0e3a 8f      GLO      Rf
0e3b f4      ADD     
0e3c 73      STXD    
0e3d 29      DEC      R9
0e3e 8f      GLO      Rf
0e3f f5      SD      
0e40 59      STR      R9
0e41 c00dfc  LBR      0dfc

0e44  ;$0e24 0e02
0e44 d5      RETN    

0e45  ;=rotate bit from EF4  [R9]209e<<, status in [R8]204a
      ; return 2 if EF1=0
      ; return 1 if last 4 bits 1
      ; else return 0
0e45  ;*0595 0528 0485 041c 0407 03f0 
0e45 f84a    LDI      #4a
0e47 a8      PLO      R8               ; R8=204a
0e48 f89e    LDI      #9e
0e4a a9      PLO      R9               ; R9=209e
0e4b f802    LDI      #02
0e4d af      PLO      Rf               ; Rf=..02
0e4e 3c5e    BN1      0e5e
0e50 2f      DEC      Rf
0e51 09      LDN      R9               ; [209e]<<=1
0e52 fe      SHL
0e53 59      STR      R9
0e54 375d    B4       0e5d             ; if EF4=0 -> [209e]|=1
0e56 f901    ORI      #01
0e58 59      STR      R9
0e59 fb0f    XRI      #0f
0e5b 325e    BZ       0e5e
0e5d  ;$0e54
0e5d 2f      DEC      Rf
0e5e  ;$0e5b 0e4e
0e5e 8f      GLO      Rf
0e5f 58      STR      R8
0e60 d5      RETN    

0e61  ;*0bd5 
0e61 f800    LDI      #00
0e63 af      PLO      Rf
0e64 ae      PLO      Re
0e65 ad      PLO      Rd
0e66 f894    LDI      #94              ; R8=2094
0e68 a8      PLO      R8
0e69 f885    LDI      #85              ; R9=2085
0e6b a9      PLO      R9
0e6c f848    LDI      #48              ; Ra=2048
0e6e aa      PLO      Ra
0e6f f81f    LDI      #1f              ; Rb=201f
0e71 ab      PLO      Rb
0e72 0b      LDN      Rb
0e73 fe      SHL     
0e74 3b77    BNF      0e77
0e76 1f      INC      Rf
0e77  ;$0e74
0e77 2b      DEC      Rb
0e78 f886    LDI      #86              ; Rc=2086
0e7a ac      PLO      Rc
0e7b ec      SEX      Rc
0e7c f820    LDI      #20
0e7e f5      SD      
0e7f 1c      INC      Rc
0e80 f803    LDI      #03
0e82 75      SDB     
0e83 3386    BDF      0e86
0e85 1d      INC      Rd
0e86  ;$0e83
0e86 f88d    LDI      #8d              ; Rc=208d
0e88 ac      PLO      Rc
0e89 08      LDN      R8
0e8a fa20    ANI      #20
0e8c 328f    BZ       0e8f
0e8e 1e      INC      Re
0e8f  ;$0e8c
0e8f 08      LDN      R8
0e90 fa08    ANI      #08
0e92 32ab    BZ       0eab
0e94 8f      GLO      Rf
0e95 c20f14  LBZ      0f14
0e98 0a      LDN      Ra
0e99 f6      SHR     
0e9a 3b9d    BNF      0e9d
0e9c d5      RETN    

0e9d  ;$0e9a
0e9d f889    LDI      #89              ; Rb=2089
0e9f ab      PLO      Rb
0ea0 0b      LDN      Rb
0ea1 ca0f91  LBNZ     0f91
0ea4 f802    LDI      #02
0ea6 73      STXD    
0ea7 f8ee    LDI      #ee
0ea9 5c      STR      Rc
0eaa d5      RETN    

0eab  ;$0e92
0eab 09      LDN      R9
0eac c20f14  LBZ      0f14
0eaf ff01    SMI      #01
0eb1 3ac4    BNZ      0ec4
0eb3 f8a1    LDI      #a1              ; Rb=20a1
0eb5 ab      PLO      Rb
0eb6 0b      LDN      Rb
0eb7 32be    BZ       0ebe
0eb9 f81e    LDI      #1e              ; Rb=201e
0ebb ab      PLO      Rb
0ebc 30d2    BR       0ed2

0ebe  ;$0eb7
0ebe 8f      GLO      Rf
0ebf c20f14  LBZ      0f14
0ec2 30fa    BR       0efa

0ec4  ;$0eb1
0ec4 ff01    SMI      #01
0ec6 32d2    BZ       0ed2
0ec8 8e      GLO      Re
0ec9 c20f02  LBZ      0f02
0ecc 09      LDN      R9
0ecd ff03    SMI      #03
0ecf ca0f02  LBNZ     0f02
0ed2  ;$0ec6 0ebc
0ed2 8f      GLO      Rf
0ed3 3ae2    BNZ      0ee2
0ed5 8e      GLO      Re
0ed6 c20f05  LBZ      0f05
0ed9 09      LDN      R9
0eda ff03    SMI      #03
0edc c20f05  LBZ      0f05
0edf c00f14  LBR      0f14

0ee2  ;$0ed3
0ee2 f889    LDI      #89
0ee4 ab      PLO      Rb
0ee5 0b      LDN      Rb
0ee6 32ee    BZ       0eee
0ee8 0a      LDN      Ra
0ee9 f6      SHR     
0eea cb0f91  LBNF     0f91
0eed d5      RETN    

0eee  ;$0ee6
0eee 8e      GLO      Re
0eef 32f6    BZ       0ef6
0ef1 09      LDN      R9
0ef2 ff02    SMI      #02
0ef4 32fa    BZ       0efa
0ef6  ;$0eef
0ef6 8d      GLO      Rd
0ef7 ca0f18  LBNZ     0f18
0efa  ;$0ef4 0ec2
0efa f803    LDI      #03
0efc 73      STXD    
0efd f820    LDI      #20
0eff 5c      STR      Rc
0f00 3078    BR       0f78

0f02  ;$0ecf 0ec9 
0f02 8f      GLO      Rf
0f03 3a91    BNZ      0f91
0f05  ;$0edc 0ed6 
0f05 8d      GLO      Rd
0f06 3a22    BNZ      0f22
0f08 f814    LDI      #14              ; Ra=2014
0f0a aa      PLO      Ra
0f0b eb      SEX      Rb
0f0c 4a      LDA      Ra
0f0d f5      SD      
0f0e 1b      INC      Rb
0f0f 0a      LDN      Ra
0f10 75      SDB     
0f11 ec      SEX      Rc
0f12 3b18    BNF      0f18
0f14  ;$0edf 0ebf 0eac 0e95 
0f14 f8ff    LDI      #ff
0f16 73      STXD    
0f17 d5      RETN    

0f18  ;$0f12 0ef7
0f18 f887    LDI      #87              ; R9=2087
0f1a a9      PLO      R9
0f1b 09      LDN      R9
0f1c 73      STXD    
0f1d 29      DEC      R9
0f1e 09      LDN      R9
0f1f 5c      STR      Rc
0f20 3078    BR       0f78

0f22  ;$0f06
0f22 f800    LDI      #00
0f24 73      STXD    
0f25 5c      STR      Rc
0f26 f814    LDI      #14              ; Ra=2014
0f28 aa      PLO      Ra
0f29 f89c    LDI      #9c              ; R9=209c
0f2b a9      PLO      R9
0f2c e9      SEX      R9
0f2d 4b      LDA      Rb
0f2e 59      STR      R9
0f2f 19      INC      R9
0f30 0b      LDN      Rb
0f31 73      STXD    
0f32 f804    LDI      #04
0f34 ad      PLO      Rd
0f35 f6      SHR     
0f36 af      PLO      Rf
0f37  ;$0f6b
0f37 f89a    LDI      #9a              ; R8=209a
0f39 a8      PLO      R8
0f3a e8      SEX      R8
0f3b 4a      LDA      Ra
0f3c 58      STR      R8
0f3d 18      INC      R8
0f3e 0a      LDN      Ra
0f3f 73      STXD    
0f40 2a      DEC      Ra
0f41 8d      GLO      Rd
0f42 f6      SHR     
0f43 3350    BDF      0f50
0f45  ;$0f4e
0f45 08      LDN      R8
0f46 fe      SHL     
0f47 58      STR      R8
0f48 18      INC      R8
0f49 08      LDN      R8
0f4a 7e      SHLC    
0f4b 73      STXD    
0f4c 2f      DEC      Rf
0f4d 8f      GLO      Rf
0f4e 3a45    BNZ      0f45
0f50  ;$0f62 0f43
0f50 49      LDA      R9
0f51 f7      SM      
0f52 ae      PLO      Re
0f53 18      INC      R8
0f54 09      LDN      R9
0f55 77      SMB     
0f56 3b64    BNF      0f64
0f58 e9      SEX      R9
0f59 73      STXD    
0f5a 8e      GLO      Re
0f5b 59      STR      R9
0f5c ec      SEX      Rc
0f5d 8d      GLO      Rd
0f5e f4      ADD     
0f5f 5c      STR      Rc
0f60 e8      SEX      R8
0f61 28      DEC      R8
0f62 3050    BR       0f50

0f64  ;$0f56
0f64 29      DEC      R9
0f65 8d      GLO      Rd
0f66 f6      SHR     
0f67 336d    BDF      0f6d
0f69 f6      SHR     
0f6a ad      PLO      Rd
0f6b 3037    BR       0f37

0f6d  ;$0f67
0f6d 0c      LDN      Rc
0f6e fc01    ADI      #01
0f70 59      STR      R9
0f71 d40d24  CALL     0d24             ; Wlh[208c]=B[209c]*Wlh[2086]
0f74 86      DB       86 9c 8c 01

0f78  ;$0f20 0f00
0f78 f88a    LDI      #8a
0f7a ab      PLO      Rb
0f7b ec      SEX      Rc
0f7c 0b      LDN      Rb
0f7d f5      SD      
0f7e 5c      STR      Rc
0f7f 1b      INC      Rb
0f80 1c      INC      Rc
0f81 0b      LDN      Rb
0f82 75      SDB     
0f83 5c      STR      Rc
0f84 2c      DEC      Rc
0f85 0c      LDN      Rc
0f86 ff32    SMI      #32
0f88 5c      STR      Rc
0f89 1c      INC      Rc
0f8a 0c      LDN      Rc
0f8b 7f00    SMBI     #00
0f8d 5c      STR      Rc
0f8e c30f95  LBDF     0f95
0f91  ;$0f03 0eea 0ea1
0f91 f800    LDI      #00
0f93 73      STXD    
0f94 5c      STR      Rc
0f95  ;$0f8e
0f95 d5      RETN    

0f96  ;*0592 
0f96 ec      SEX      Rc
0f97 0b      LDN      Rb
0f98 3abf    BNZ      0fbf
0f9a f819    LDI      #19
0f9c 5b      STR      Rb
0f9d f808    LDI      #08              ; loop 8 times
0f9f af      PLO      Rf
0fa0 f808    LDI      #08
0fa2 ac      PLO      Rc

0fa3  ;$0fa8
0fa3 9d      GHI      Rd
0fa4 f1      OR      
0fa5 73      STXD                      ; [Rc--] |= Rdh
0fa6 2f      DEC      Rf
0fa7 8f      GLO      Rf
0fa8 3aa3    BNZ      0fa3

0faa 0e      LDN      Re
0fab 3ab3    BNZ      0fb3
0fad f877    LDI      #77
0faf ae      PLO      Re
0fb0 f817    LDI      #17
0fb2 be      PHI      Re               ; Re=1777
0fb3  ;$0fab
0fb3 f803    LDI      #03
0fb5 af      PLO      Rf

0fb6  ;$0fbd
0fb6 4e      LDA      Re               ; Rc=2000 + B[Re++]
0fb7 ac      PLO      Rc
0fb8 8d      GLO      Rd
0fb9 f2      AND     
0fba 5c      STR      Rc               ; [Rc]&=Rdl
0fbb 2f      DEC      Rf
0fbc 8f      GLO      Rf
0fbd 3ab6    BNZ      0fb6

0fbf  ;$0f98
0fbf d5      RETN    

0fc0  ;= zeroes upto 0fff

1000  ;$0002 
1000 f820    LDI      #20              ; R6-Rc=20xx
1002 b6      PHI      R6
1003 b7      PHI      R7
1004 b8      PHI      R8
1005 b9      PHI      R9
1006 ba      PHI      Ra
1007 bb      PHI      Rb
1008 bc      PHI      Rc
1009 b2      PHI      R2
100a f8df    LDI      #df              ; R2=20df
100c a2      PLO      R2
100d f800    LDI      #00              ; R6=2000
100f a6      PLO      R6
1010 b4      PHI      R4
1011 b5      PHI      R5
1012 b1      PHI      R1
1013 f842    LDI      #42              ; R1=0042
1015 a1      PLO      R1
1016 f806    LDI      #06              ; R4=0006
1018 a4      PLO      R4
1019 f818    LDI      #18              ; R5=0018
101b a5      PLO      R5
101c e0      SEX      R0
101d 61      OUT      D1
101e 08      DB       08
101f 61      OUT      D1
1020 00      DB       00
1021 61      OUT      D1
1022 00      DB       00
1023 61      OUT      D1
1024 00      DB       00
1025 61      OUT      D1
1026 00      DB       00
1027 61      OUT      D1
1028 00      DB       00
1029 61      OUT      D1
102a 00      DB       00
102b 61      OUT      D1
102c 00      DB       00
102d e6      SEX      R6
102e 64      OUT      D4
102f 67      OUT      D7
1030 f800    LDI      #00              ; R6=2000
1032 a6      PLO      R6
1033 e2      SEX      R2
1034 6c      INP      D4
1035 fbff    XRI      #ff
1037 fa04    ANI      #04
1039 56      STR      R6
103a 02      LDN      R2
103b fa08    ANI      #08
103d 3243    BZ       1043
103f 06      LDN      R6
1040 f902    ORI      #02
1042 56      STR      R6
1043  ;$103d
1043 3c49    BN1      1049
1045 06      LDN      R6
1046 f901    ORI      #01
1048 56      STR      R6
1049  ;$1043
1049 6a      INP      D2
104a fa40    ANI      #40
104c 3252    BZ       1052
104e 06      LDN      R6
104f f908    ORI      #08
1051 56      STR      R6
1052  ;$104c
1052 06      LDN      R6
1053 fa04    ANI      #04
1055 3a5d    BNZ      105d
1057 3d5d    BN2      105d
1059 06      LDN      R6
105a f980    ORI      #80
105c 56      STR      R6
105d  ;$1057 1055
105d f80a    LDI      #0a              ; R6=200a
105f a6      PLO      R6
1060 e6      SEX      R6
1061 f8ff    LDI      #ff
1063 73      STXD    
1064 73      STXD    
1065 f801    LDI      #01
1067 73      STXD    
1068 f801    LDI      #01
106a 73      STXD    
106b f809    LDI      #09
106d 73      STXD    
106e f80b    LDI      #0b
1070 73      STXD    
1071 f801    LDI      #01
1073 73      STXD    
1074 f803    LDI      #03
1076 73      STXD    
1077 f803    LDI      #03
1079 73      STXD    
107a f809    LDI      #09
107c 73      STXD    
107d d40d5a  CALL     0d5a             ; clear 200b-20df
1080 df      DB       df d5

1082 f847    LDI      #47              ; R6=2047
1084 a6      PLO      R6
1085 f801    LDI      #01              ; B[2047]=1
1087 56      STR      R6

1088 e0      SEX      R0
1089 70      RET
108a 00      DB       00               ; set X=0, P=0

108b d40d87  CALL     0d87             ; Q=1 for 3 ticks
108e         DB       03

108f 71      DIS                       ; set X=6, P=0
1090 60      DB       60

1091 f81d    LDI      #1d              ; R6=201d
1093 a6      PLO      R6
1094 f804    LDI      #04
1096 73      STXD    
1097 f803    LDI      #03
1099 73      STXD    
109a f800    LDI      #00
109c 73      STXD    
109d f864    LDI      #64
109f 73      STXD    
10a0 f800    LDI      #00
10a2 73      STXD    
10a3 f819    LDI      #19
10a5 73      STXD    
10a6 f83f    LDI      #3f              ; R6=203f
10a8 a6      PLO      R6
10a9 e2      SEX      R2
10aa 6a      INP      D2
10ab 6c      INP      D4
10ac 6c      INP      D4
10ad 6c      INP      D4
10ae 6c      INP      D4
10af f806    LDI      #06
10b1 af      PLO      Rf
10b2  ;$10bb
10b2 6c      INP      D4
10b3 f6      SHR     
10b4 f6      SHR     
10b5 f6      SHR     
10b6 f6      SHR     
10b7 16      INC      R6
10b8 56      STR      R6
10b9 2f      DEC      Rf
10ba 8f      GLO      Rf
10bb 3ab2    BNZ      10b2
10bd 46      LDA      R6
10be 56      STR      R6
10bf f89a    LDI      #9a              ; R7=209a
10c1 a7      PLO      R7
10c2 f80a    LDI      #0a
10c4 57      STR      R7
10c5 d40d24  CALL     0d24             ; Wlh[2014]=B[209a]*B[2040]
10c8 40      DB       40 9a 14 00

10cc f841    LDI      #41              ; R6=2041
10ce a6      PLO      R6
10cf 06      LDN      R6
10d0 57      STR      R7
10d1 17      INC      R7
10d2 f800    LDI      #00
10d4 57      STR      R7
10d5 27      DEC      R7
10d6 d40d67  CALL     0d67             ; Wlh[2014]=Wlh[2014]+Wlh[209a]
10d9         DB       14 9a 14

10dc f819    LDI      #19
10de 57      STR      R7
10df d40d24  CALL     0d24             ; Wlh[2010]=B[209a]*B[2042]
10e2 42      DB       42 9a 10 00

10e6 f81e    LDI      #1e
10e8 57      STR      R7
10e9 d40d24  CALL     0d24             ; Wlh[2012]=B[209a]*B[2043]
10ec 43      DB       43 9a 12 00

10f0 f847    LDI      #47              ; R6=2047
10f2 a6      PLO      R6
10f3 f801    LDI      #01              ; B[2047]=1
10f5 56      STR      R6

10f6 e0      SEX      R0
10f7 70      RET
10f8 60      DB       60               ; set X=6, P=0

10f9 d40d87  CALL     0d87             ; Q=1 for 3 ticks
10fc         DB       03

10fd f800    LDI      #00
10ff 56      STR      R6
1100 f800    LDI      #00              ; R6=2000
1102 a6      PLO      R6
1103 06      LDN      R6
1104 fe      SHL     
1105 c31358  LBDF     1358
1108 06      LDN      R6
1109 fa02    ANI      #02
110b 3a1c    BNZ      111c
110d f8e6    LDI      #e6              ; R7=20e6
110f a7      PLO      R7
1110 e7      SEX      R7
1111 f800    LDI      #00
1113 73      STXD    
1114 73      STXD    
1115 73      STXD    
1116 73      STXD    
1117 27      DEC      R7
1118 27      DEC      R7
1119 f8aa    LDI      #aa
111b 57      STR      R7
111c  ;$110b
111c 06      LDN      R6
111d ff02    SMI      #02
111f ce      LSZ     
1120 ff02    SMI      #02
1122 ce      LSZ     
1123 ff02    SMI      #02
1125 ce      LSZ     
1126 ff04    SMI      #04
1128 c21351  LBZ      1351
112b d40700  CALL     0700
112e 06      LDN      R6
112f ff05    SMI      #05
1131 ce      LSZ     
1132 ff02    SMI      #02
1134 c214f8  LBZ      14f8
1137 06      LDN      R6
1138 ce      LSZ     
1139 ff08    SMI      #08
113b c2163b  LBZ      163b
113e 06      LDN      R6
113f ff0c    SMI      #0c
1141 ce      LSZ     
1142 ff01    SMI      #01
1144 ce      LSZ     
1145 ff01    SMI      #01
1147 ce      LSZ     
1148 ff01    SMI      #01
114a c215cf  LBZ      15cf
114d f84b    LDI      #4b              ; R7=204b
114f a7      PLO      R7
1150 07      LDN      R7
1151 fb03    XRI      #03
1153 3a71    BNZ      1171
1155 f836    LDI      #36              ; R7=2036
1157 a7      PLO      R7
1158 07      LDN      R7
1159 ff31    SMI      #31
115b 3a7c    BNZ      117c
115d f892    LDI      #92              ; R6=2092
115f a6      PLO      R6
1160 f83c    LDI      #3c
1162 56      STR      R6
1163  ;$116c
1163 7b      SEQ     
1164 3769    B4       1169
1166 c003bb  LBR      03bb

1169  ;$1164
1169 3c6e    BN1      116e
116b 06      LDN      R6
116c 3a63    BNZ      1163
116e  ;$1169
116e c01358  LBR      1358

1171  ;$1153
1171 17      INC      R7
1172 07      LDN      R7
1173 fb04    XRI      #04
1175 327c    BZ       117c
1177 07      LDN      R7
1178 fb05    XRI      #05
117a 3a8b    BNZ      118b
117c  ;$1175 115b
117c f838    LDI      #38              ; R6=2038
117e a6      PLO      R6
117f f800    LDI      #00
1181 56      STR      R6
1182 f811    LDI      #11              ; R7=2011
1184 a7      PLO      R7
1185 f8ff    LDI      #ff
1187 57      STR      R7
1188 17      INC      R7
1189 17      INC      R7
118a 57      STR      R7
118b  ;$146b 117a
118b 7b      SEQ     
118c f89a    LDI      #9a              ; R7=209a
118e a7      PLO      R7
118f f805    LDI      #05
1191 57      STR      R7
1192 d40d24  CALL     0d24             ; Wlh[2016]=B[209a]*B[2044]
1195 44      DB       44 9a 16 00

1199 f806    LDI      #06              ; R6=2006
119b a6      PLO      R6
119c 06      LDN      R6
119d f902    ORI      #02
119f 56      STR      R6
11a0 f848    LDI      #48              ; R7=2048
11a2 a7      PLO      R7
11a3 07      LDN      R7
11a4 f901    ORI      #01
11a6 57      STR      R7
11a7 d40d5a  CALL     0d5a             ; clear 2060-20bf
11aa bf      DB       bf 60

11ac f876    LDI      #76              ; R6=2076
11ae a6      PLO      R6
11af e6      SEX      R6
11b0 f874    LDI      #74
11b2 73      STXD    
11b3 73      STXD    
11b4 f838    LDI      #38              ; R6=2038
11b6 a6      PLO      R6
11b7 06      LDN      R6
11b8 32be    BZ       11be
11ba f889    LDI      #89              ; R6=2089
11bc a6      PLO      R6
11bd 56      STR      R6
11be  ;$11b8
11be f892    LDI      #92              ; R6=2092
11c0 a6      PLO      R6
11c1 f83c    LDI      #3c
11c3 56      STR      R6
11c4 f845    LDI      #45              ; R6=2045
11c6 a6      PLO      R6
11c7 46      LDA      R6
11c8 56      STR      R6
11c9 fa04    ANI      #04
11cb 32d1    BZ       11d1
11cd 07      LDN      R7
11ce f904    ORI      #04
11d0 57      STR      R7
11d1  ;$126b 1264 125b 11cb
11d1 7b      SEQ     
11d2 e6      SEX      R6
11d3 34d8    B1       11d8
11d5 c0135f  LBR      135f

11d8  ;$11d3
11d8 f892    LDI      #92              ; R6=2092
11da a6      PLO      R6
11db 06      LDN      R6
11dc c21210  LBZ      1210
11df ff3b    SMI      #3b
11e1 c31226  LBDF     1226
11e4 f894    LDI      #94              ; R6=2094
11e6 a6      PLO      R6
11e7 06      LDN      R6
11e8 fa42    ANI      #42
11ea fb42    XRI      #42
11ec c21208  LBZ      1208
11ef f836    LDI      #36              ; R6=2036
11f1 a6      PLO      R6
11f2 06      LDN      R6
11f3 fb32    XRI      #32
11f5 c21226  LBZ      1226
11f8 26      DEC      R6
11f9 06      LDN      R6
11fa fb32    XRI      #32
11fc c21226  LBZ      1226
11ff 17      INC      R7
1200 07      LDN      R7
1201 f901    ORI      #01
1203 57      STR      R7
1204 27      DEC      R7
1205 c01220  LBR      1220

1208  ;$11ec 
1208 17      INC      R7
1209 f800    LDI      #00
120b 57      STR      R7
120c 27      DEC      R7
120d c01226  LBR      1226

1210  ;$11dc 
1210 f875    LDI      #75              ; R6=2075
1212 a6      PLO      R6
1213 f874    LDI      #74
1215 f3      XOR     
1216 3a20    BNZ      1220
1218 f80c    LDI      #0c              ; R6=200c
121a a6      PLO      R6
121b 46      LDA      R6
121c f1      OR      
121d c21351  LBZ      1351
1220  ;$1216 1205
1220 f885    LDI      #85              ; R6=2085
1222 a6      PLO      R6
1223 06      LDN      R6
1224 3a80    BNZ      1280
1226  ;$120d 11fc 11f5 11e1 
1226 f837    LDI      #37              ; R6=2037
1228 a6      PLO      R6
1229 f83d    LDI      #3d              ; R8=203d
122b a8      PLO      R8
122c f896    LDI      #96              ; R9=2096
122e a9      PLO      R9
122f 08      LDN      R8
1230 f1      OR      
1231 e9      SEX      R9
1232 f1      OR      
1233 3a41    BNZ      1241
1235 373a    B4       123a
1237 c003bb  LBR      03bb

123a  ;$1235
123a e2      SEX      R2
123b 6c      INP      D4
123c fa02    ANI      #02
123e c21512  LBZ      1512
1241  ;$1233
1241 d40b50  CALL     0b50
1244 f848    LDI      #48              ; R7=2048
1246 a7      PLO      R7
1247 f894    LDI      #94              ; R6=2094
1249 a6      PLO      R6
124a 06      LDN      R6
124b fe      SHL     
124c 3380    BDF      1280
124e fe      SHL     
124f 3b5e    BNF      125e
1251 f889    LDI      #89              ; R8=2089
1253 a8      PLO      R8
1254 f800    LDI      #00
1256 58      STR      R8
1257 07      LDN      R7
1258 fafb    ANI      #fb
125a 57      STR      R7
125b c011d1  LBR      11d1

125e  ;$124f
125e d40d77  CALL     0d77             ; Wlh[209c]=Wlh[201e]-Wlh[2010]
1261         DB       1e 10 9c


1264 cb11d1  LBNF     11d1
1267 08      LDN      R8
1268 28      DEC      R8
1269 e8      SEX      R8
126a f1      OR      
126b c211d1  LBZ      11d1
126e f880    LDI      #80              ; R8=2080
1270 a8      PLO      R8
1271 f801    LDI      #01
1273 58      STR      R8
1274 07      LDN      R7
1275 f904    ORI      #04
1277 57      STR      R7
1278 f889    LDI      #89              ; R8=2089
127a a8      PLO      R8
127b f800    LDI      #00
127d 58      STR      R8
127e 3083    BR       1283

1280  ;$1294 1290 124c 1224
1280 c0135f  LBR      135f

1283  ;$1332 1317 1311 127e
1283 7b      SEQ     
1284 f892    LDI      #92              ; R8=2092
1286 a8      PLO      R8
1287 08      LDN      R8
1288 ff3b    SMI      #3b
128a 3390    BDF      1290
128c 17      INC      R7
128d f803    LDI      #03
128f 57      STR      R7
1290  ;$128a
1290 3c80    BN1      1280
1292 06      LDN      R6
1293 fe      SHL     
1294 3380    BDF      1280
1296 06      LDN      R6
1297 f6      SHR     
1298 3ba0    BNF      12a0
129a 27      DEC      R7
129b 07      LDN      R7
129c fafb    ANI      #fb
129e 57      STR      R7
129f 17      INC      R7
12a0  ;$1298
12a0 06      LDN      R6
12a1 f6      SHR     
12a2 f6      SHR     
12a3 3ba8    BNF      12a8
12a5 f800    LDI      #00
12a7 57      STR      R7
12a8  ;$12a3
12a8 d40b50  CALL     0b50
12ab f848    LDI      #48              ; R7=2048
12ad a7      PLO      R7
12ae f889    LDI      #89
12b0 ac      PLO      Rc
12b1 f88e    LDI      #8e
12b3 ab      PLO      Rb
12b4 f805    LDI      #05              ; Ra=2005
12b6 aa      PLO      Ra
12b7 f885    LDI      #85              ; R8=2085
12b9 a8      PLO      R8
12ba 08      LDN      R8
12bb 32ea    BZ       12ea
12bd f846    LDI      #46              ; R8=2046
12bf a8      PLO      R8
12c0 08      LDN      R8
12c1 f901    ORI      #01
12c3 58      STR      R8
12c4 07      LDN      R7
12c5 f906    ORI      #06
12c7 57      STR      R7
12c8 06      LDN      R6
12c9 fafe    ANI      #fe
12cb 56      STR      R6
12cc f88c    LDI      #8c              ; R8=208c
12ce a8      PLO      R8
12cf e8      SEX      R8
12d0 48      LDA      R8
12d1 f1      OR      
12d2 c21335  LBZ      1335
12d5 28      DEC      R8
12d6 48      LDA      R8
12d7 ffef    SMI      #ef
12d9 08      LDN      R8
12da 7f02    SMBI     #02
12dc 3be4    BNF      12e4
12de f800    LDI      #00
12e0 5c      STR      Rc
12e1 c01314  LBR      1314

12e4  ;$12dc
12e4 0c      LDN      Rc
12e5 3aea    BNZ      12ea
12e7 f801    LDI      #01
12e9 5c      STR      Rc
12ea  ;$12e5 12bb
12ea 0c      LDN      Rc
12eb c21314  LBZ      1314
12ee fb02    XRI      #02
12f0 c21310  LBZ      1310
12f3 ea      SEX      Ra
12f4 0a      LDN      Ra
12f5 fafe    ANI      #fe
12f7 73      STXD    
12f8 2a      DEC      Ra
12f9 0a      LDN      Ra
12fa fafe    ANI      #fe
12fc f908    ORI      #08
12fe 73      STXD    
12ff 2a      DEC      Ra
1300 0a      LDN      Ra
1301 fafe    ANI      #fe
1303 f902    ORI      #02
1305 5a      STR      Ra
1306 f832    LDI      #32
1308 5b      STR      Rb
1309 07      LDN      R7
130a f940    ORI      #40
130c 57      STR      R7
130d f802    LDI      #02
130f 5c      STR      Rc
1310  ;$134c 12f0 
1310 0b      LDN      Rb
1311 ca1283  LBNZ     1283
1314  ;$12eb 12e1 
1314 07      LDN      R7
1315 fe      SHL     
1316 fe      SHL     
1317 cb1283  LBNF     1283
131a 07      LDN      R7
131b fabf    ANI      #bf
131d 57      STR      R7
131e ea      SEX      Ra
131f 0a      LDN      Ra
1320 f901    ORI      #01
1322 73      STXD    
1323 2a      DEC      Ra
1324 0a      LDN      Ra
1325 faf7    ANI      #f7
1327 f901    ORI      #01
1329 73      STXD    
132a 0a      LDN      Ra
132b f902    ORI      #02
132d 73      STXD    
132e 0a      LDN      Ra
132f f901    ORI      #01
1331 5a      STR      Ra
1332 c01283  LBR      1283

1335  ;$12d2 
1335 f81e    LDI      #1e              ; R8=201e
1337 a8      PLO      R8
1338 e8      SEX      R8
1339 48      LDA      R8
133a f1      OR      
133b 324f    BZ       134f
133d 08      LDN      R8
133e fe      SHL     
133f 334f    BDF      134f
1341 d40d77  CALL     0d77             ; Wlh[209c]=Wlh[201e]-Wlh[2014]
1344         DB       1e 14 9c

1347 3b4f    BNF      134f
1349 f805    LDI      #05              ; Ra=2005
134b aa      PLO      Ra
134c c01310  LBR      1310

134f  ;$1347 133f 133b
134f 305f    BR       135f

1351  ;$164a 1638 15e8 121d 1128
1351 f848    LDI      #48              ; R7=2048
1353 a7      PLO      R7
1354 07      LDN      R7
1355 f980    ORI      #80
1357 57      STR      R7
1358  ;$150c 116e 1105 059d 0530 0490 0424 040f 03f8 
1358 f848    LDI      #48              ; R7=2048
135a a7      PLO      R7
135b 07      LDN      R7
135c f908    ORI      #08
135e 57      STR      R7
135f  ;$134f 1562 1533 1280 11d5
135f 7b      SEQ     
1360 f89f    LDI      #9f              ; R6=209f
1362 a6      PLO      R6
1363 f800    LDI      #00
1365 56      STR      R6
1366 16      INC      R6
1367 56      STR      R6
1368 f80a    LDI      #0a              ; R6=200a
136a a6      PLO      R6
136b e6      SEX      R6
136c f8ff    LDI      #ff
136e 73      STXD    
136f 73      STXD    
1370 06      LDN      R6
1371 f901    ORI      #01
1373 73      STXD    
1374 06      LDN      R6
1375 f909    ORI      #09
1377 73      STXD    
1378 06      LDN      R6
1379 f901    ORI      #01
137b 73      STXD    
137c 06      LDN      R6
137d f903    ORI      #03
137f 73      STXD    
1380 06      LDN      R6
1381 f901    ORI      #01
1383 73      STXD    
1384 06      LDN      R6
1385 f901    ORI      #01
1387 faf7    ANI      #f7
1389 73      STXD    
138a 06      LDN      R6
138b f903    ORI      #03
138d 73      STXD    
138e 06      LDN      R6
138f f901    ORI      #01
1391 73      STXD    
1392 f889    LDI      #89              ; R8=2089
1394 a8      PLO      R8
1395 f800    LDI      #00
1397 58      STR      R8
1398 f848    LDI      #48              ; R7=2048
139a a7      PLO      R7
139b 07      LDN      R7
139c faa8    ANI      #a8
139e 57      STR      R7
139f f88e    LDI      #8e              ; R6=208e
13a1 a6      PLO      R6
13a2 f832    LDI      #32
13a4 56      STR      R6
13a5  ;$13bd
13a5 f837    LDI      #37              ; R8=2037
13a7 a8      PLO      R8
13a8 08      LDN      R8
13a9 32b0    BZ       13b0
13ab d40a00  CALL     0a00
13ae 30b3    BR       13b3

13b0  ;$13a9
13b0 d40c00  CALL     0c00
13b3  ;$13ae
13b3 7b      SEQ     
13b4 f837    LDI      #37              ; R8=2037
13b6 a8      PLO      R8
13b7 f83d    LDI      #3d              ; R9=203d
13b9 a9      PLO      R9
13ba 08      LDN      R8
13bb e9      SEX      R9
13bc f1      OR      
13bd 3aa5    BNZ      13a5
13bf  ;$13e9
13bf 7b      SEQ     
13c0 f884    LDI      #84
13c2 ab      PLO      Rb
13c3 4b      LDA      Rb
13c4 32e8    BZ       13e8
13c6 0b      LDN      Rb
13c7 fb01    XRI      #01
13c9 3ad7    BNZ      13d7
13cb d40d77  CALL     0d77             ; Wlh[201e]=Wlh[201e]-Wlh[2016]
13ce         DB       1e 16 1e

13d1 d40d67  CALL     0d67             ; Wlh[204e]=Wlh[204e]+Wlh[2016]
13d4         DB       4e 16 4e

13d7  ;$13c9
13d7 d40d77  CALL     0d77             ; Wlh[201e]=Wlh[201e]-Wlh[2014]
13da         DB       1e 14 1e

13dd d40d67  CALL     0d67             ; Wlh[204e]=Wlh[204e]+Wlh[2014]
13e0         DB       4e 14 4e

13e3 2b      DEC      Rb
13e4 0b      LDN      Rb
13e5 ff01    SMI      #01
13e7 5b      STR      Rb
13e8  ;$13c4
13e8 06      LDN      R6
13e9 3abf    BNZ      13bf
13eb 17      INC      R7
13ec f800    LDI      #00
13ee 57      STR      R7
13ef 27      DEC      R7
13f0 f84a    LDI      #4a              ; R8=204a
13f2 a8      PLO      R8
13f3 08      LDN      R8
13f4 ca140a  LBNZ     140a
13f7 f8ec    LDI      #ec              ; R8=20ec
13f9 a8      PLO      R8
13fa f885    LDI      #85              ; Ra=2085
13fc aa      PLO      Ra
13fd 0a      LDN      Ra
13fe ca140d  LBNZ     140d
1401 08      LDN      R8
1402 fe      SHL     
1403 c3140a  LBDF     140a
1406 08      LDN      R8
1407 fc01    ADI      #01
1409 58      STR      R8
140a  ;$1403 13f4 
140a c0142e  LBR      142e

140d  ;$13fe 
140d f8ea    LDI      #ea              ; R9=20ea
140f a9      PLO      R9
1410 f80f    LDI      #0f
1412 e9      SEX      R9
1413 f5      SD      
1414 19      INC      R9
1415 f827    LDI      #27
1417 75      SDB     
1418 c31427  LBDF     1427
141b 29      DEC      R9
141c f801    LDI      #01
141e f4      ADD     
141f 59      STR      R9
1420 19      INC      R9
1421 f800    LDI      #00
1423 74      ADC     
1424 59      STR      R9
1425 302b    BR       142b

1427  ;$1418 
1427 f800    LDI      #00
1429 73      STXD    
142a 59      STR      R9
142b  ;$1425
142b f800    LDI      #00
142d 58      STR      R8
142e  ;$140a 
142e e9      SEX      R9
142f 07      LDN      R7
1430 fa20    ANI      #20
1432 324b    BZ       144b
1434 f8e2    LDI      #e2              ; R8=20e2
1436 a8      PLO      R8
1437 f81f    LDI      #1f              ; R9=201f
1439 a9      PLO      R9
143a 08      LDN      R8
143b 73      STXD    
143c 28      DEC      R8
143d 08      LDN      R8
143e 59      STR      R9
143f f84e    LDI      #4e              ; R9=204e
1441 a9      PLO      R9
1442 49      LDA      R9
1443 58      STR      R8
1444 18      INC      R8
1445 09      LDN      R9
1446 58      STR      R8
1447 07      LDN      R7
1448 fadf    ANI      #df
144a 57      STR      R7
144b  ;$1432
144b f81f    LDI      #1f              ; R9=201f
144d a9      PLO      R9
144e 09      LDN      R9
144f fe      SHL     
1450 3b58    BNF      1458
1452 f800    LDI      #00
1454 73      STXD    
1455 59      STR      R9
1456 306e    BR       146e

1458  ;$1450
1458 07      LDN      R7
1459 fa08    ANI      #08
145b 3a6e    BNZ      146e
145d e2      SEX      R2
145e 6c      INP      D4
145f f6      SHR     
1460 336e    BDF      146e
1462 3c6e    BN1      146e
1464 f807    LDI      #07              ; R8=2007
1466 a8      PLO      R8
1467 08      LDN      R8
1468 faf7    ANI      #f7
146a 58      STR      R8
146b c0118b  LBR      118b

146e  ;$1462 1460 145b 1456
146e f804    LDI      #04              ; R8=2004
1470 a8      PLO      R8
1471 08      LDN      R8
1472 f902    ORI      #02
1474 58      STR      R8
1475 7b      SEQ     
1476 f807    LDI      #07              ; R8=2007
1478 a8      PLO      R8
1479 08      LDN      R8
147a faf7    ANI      #f7
147c 58      STR      R8
147d f80c    LDI      #0c              ; R6=200c
147f a6      PLO      R6
1480 f881    LDI      #81              ; R8=2081
1482 a8      PLO      R8
1483 e8      SEX      R8
1484 46      LDA      R6
1485 328a    BZ       148a
1487 f880    LDI      #80
1489 58      STR      R8
148a  ;$1485
148a 06      LDN      R6
148b 3291    BZ       1491
148d f801    LDI      #01
148f f1      OR      
1490 58      STR      R8
1491  ;$148b
1491 d40dfc  CALL     0dfc
1494 f83d    LDI      #3d              ; R6=203d
1496 a6      PLO      R6
1497  ;$149e
1497 7b      SEQ     
1498 d40c52  CALL     0c52
149b 0e      DB       0e 01

149d 06      LDN      R6
149e 3a97    BNZ      1497
14a0  ;$14a7
14a0 7b      SEQ     
14a1 d40c52  CALL     0c52
14a4 0c      DB       0c 00

14a6 06      LDN      R6
14a7 3aa0    BNZ      14a0
14a9 f881    LDI      #81              ; R6=2081
14ab a6      PLO      R6
14ac f804    LDI      #04              ; R8=2004
14ae a8      PLO      R8
14af f805    LDI      #05              ; R9=2005
14b1 a9      PLO      R9
14b2 f806    LDI      #06              ; Ra=2006
14b4 aa      PLO      Ra
14b5 06      LDN      R6
14b6 32d5    BZ       14d5
14b8 f809    LDI      #09
14ba 58      STR      R8
14bb 06      LDN      R6
14bc fe      SHL     
14bd 3bc2    BNF      14c2
14bf f805    LDI      #05
14c1 59      STR      R9
14c2  ;$14bd
14c2 06      LDN      R6
14c3 f6      SHR     
14c4 3bc9    BNF      14c9
14c6 f805    LDI      #05
14c8 5a      STR      Ra
14c9  ;$14c4
14c9 7b      SEQ     
14ca 7b      SEQ     
14cb f801    LDI      #01
14cd 58      STR      R8
14ce 7b      SEQ     
14cf 7b      SEQ     
14d0 f801    LDI      #01
14d2 59      STR      R9
14d3 5a      STR      Ra
14d4 7b      SEQ     
14d5  ;$14b6
14d5 e2      SEX      R2
14d6 6c      INP      D4
14d7 f6      SHR     
14d8 e0      SEX      R0
14d9 33e4    BDF      14e4
14db 07      LDN      R7
14dc fe      SHL     
14dd 33e4    BDF      14e4
14df 3ce4    BN1      14e4
14e1 c00000  LBR      0000

14e4  ;$14df 14dd 14d9
14e4 71      DIS     
14e5 60      DB       60               ; set X=6, P=0

14e6 f801    LDI      #01              ; R6=2001
14e8 a6      PLO      R6
14e9 06      LDN      R6
14ea faf7    ANI      #f7
14ec 56      STR      R6
14ed 61      OUT      D1
14ee 61      OUT      D1
14ef 61      OUT      D1
14f0 61      OUT      D1
14f1 61      OUT      D1
14f2 61      OUT      D1
14f3 61      OUT      D1
14f4 61      OUT      D1
14f5 64      OUT      D4
14f6 00      IDL     
14f7 00      IDL     
14f8  ;$1134 
14f8 f806    LDI      #06              ; R6=2006
14fa a6      PLO      R6
14fb 06      LDN      R6
14fc f902    ORI      #02
14fe 56      STR      R6
14ff f809    LDI      #09              ; R6=2009
1501 a6      PLO      R6
1502 f800    LDI      #00
1504 56      STR      R6
1505 f84a    LDI      #4a              ; R6=204a
1507 a6      PLO      R6
1508 56      STR      R6
1509  ;$150f 
1509 7b      SEQ     
150a 340f    B1       150f
150c c01358  LBR      1358

150f  ;$150a
150f c01509  LBR      1509

1512  ;$123e 
1512 07      LDN      R7
1513 f921    ORI      #21
1515 57      STR      R7
1516 e9      SEX      R9
1517 f8e2    LDI      #e2              ; R8=20e2
1519 a8      PLO      R8
151a f84f    LDI      #4f              ; R9=204f
151c a9      PLO      R9
151d 08      LDN      R8
151e 73      STXD    
151f 28      DEC      R8
1520 08      LDN      R8
1521 59      STR      R9
1522 f81e    LDI      #1e              ; R9=201e
1524 a9      PLO      R9
1525 49      LDA      R9
1526 58      STR      R8
1527 18      INC      R8
1528 09      LDN      R9
1529 58      STR      R8
152a f850    LDI      #50              ; R6=2050
152c a6      PLO      R6
152d  ;$15cd 15be 1592
152d 7b      SEQ     
152e d40900  CALL     0900             ; dial number
1531 3436    B1       1536
1533 c0135f  LBR      135f

1536  ;$1531
1536 f892    LDI      #92              ; R8=2092
1538 a8      PLO      R8
1539 08      LDN      R8
153a ff3b    SMI      #3b
153c 3343    BDF      1543
153e 17      INC      R7
153f f803    LDI      #03
1541 57      STR      R7
1542 27      DEC      R7
1543  ;$153c
1543 f889    LDI      #89
1545 ab      PLO      Rb
1546 f84e    LDI      #4e
1548 ac      PLO      Rc
1549 ec      SEX      Rc
154a 4c      LDA      Rc
154b f1      OR      
154c 2c      DEC      Rc
154d 3a53    BNZ      1553
154f 86      GLO      R6
1550 56      STR      R6
1551 3070    BR       1570

1553  ;$154d
1553 4c      LDA      Rc
1554 ff48    SMI      #48
1556 0c      LDN      Rc
1557 2c      DEC      Rc
1558 7f26    SMBI     #26
155a 3b6d    BNF      156d
155c 06      LDN      R6
155d 3265    BZ       1565
155f f800    LDI      #00
1561 56      STR      R6
1562 c0135f  LBR      135f

1565  ;$156e 155d
1565 8b      GLO      Rb
1566 5b      STR      Rb
1567 07      LDN      R7
1568 fafb    ANI      #fb
156a 57      STR      R7
156b 3077    BR       1577

156d  ;$155a
156d 06      LDN      R6
156e 3265    BZ       1565
1570  ;$1551
1570 f800    LDI      #00
1572 5b      STR      Rb
1573 07      LDN      R7
1574 f904    ORI      #04
1576 57      STR      R7
1577  ;$156b
1577 f89e    LDI      #9e
1579 ab      PLO      Rb
157a 0b      LDN      Rb
157b fe      SHL
157c 5b      STR      Rb
157d e2      SEX      R2
157e 6c      INP      D4
157f fa02    ANI      #02
1581 3294    BZ       1594
1583 0b      LDN      Rb
1584 f901    ORI      #01
1586 5b      STR      Rb
1587 fb0f    XRI      #0f
1589 3a94    BNZ      1594
158b 5c      STR      Rc
158c 1c      INC      Rc
158d 5c      STR      Rc
158e d40dd7  CALL     0dd7
1591         DB       4e

1592 302d    BR       152d

1594  ;$1589 1581
1594 f884    LDI      #84
1596 ab      PLO      Rb
1597 0b      LDN      Rb
1598 32bc    BZ       15bc
159a ff01    SMI      #01
159c 5b      STR      Rb
159d 1b      INC      Rb
159e 0b      LDN      Rb
159f ff02    SMI      #02
15a1 33a9    BDF      15a9
15a3 d40d67  CALL     0d67             ; Wlh[204e]=Wlh[204e]+Wlh[2016]
15a6         DB       4e 16 4e

15a9  ;$15a1
15a9 d40d67  CALL     0d67             ; Wlh[204e]=Wlh[204e]+Wlh[2014]
15ac         DB       4e 14 4e

15af f846    LDI      #46              ; R8=2046
15b1 a8      PLO      R8
15b2 08      LDN      R8
15b3 f901    ORI      #01
15b5 58      STR      R8
15b6 07      LDN      R7
15b7 f902    ORI      #02
15b9 57      STR      R7
15ba 30c0    BR       15c0

15bc  ;$1598
15bc 07      LDN      R7
15bd f6      SHR     
15be 3b2d    BNF      152d
15c0  ;$15ba
15c0 d40d91  CALL     0d91             ; convert Wlh[204e] -> BCD buf[209a]
15c3         DB       4e 9a

15c5 d40dd7  CALL     0dd7
15c8         DB       9a

15c9 07      LDN      R7
15ca fafe    ANI      #fe
15cc 57      STR      R7
15cd 302d    BR       152d

15cf  ;$114a 
15cf f846    LDI      #46              ; R6=2046
15d1 a6      PLO      R6
15d2 06      LDN      R6
15d3 f901    ORI      #01
15d5 56      STR      R6
15d6 f84a    LDI      #4a              ; R6=204a
15d8 a6      PLO      R6
15d9 56      STR      R6
15da f84d    LDI      #4d              ; R6=204d
15dc a6      PLO      R6
15dd f803    LDI      #03
15df 56      STR      R6
15e0 d40d87  CALL     0d87             ; Q=1 for 32 ticks
15e3         DB       32

15e4 7b      SEQ
15e5 e2      SEX      R2
15e6 6c      INP      D4
15e7 f6      SHR     
15e8 c31351  LBDF     1351
15eb f875    LDI      #75
15ed ab      PLO      Rb
15ee f873    LDI      #73
15f0 5b      STR      Rb
15f1 1b      INC      Rb
15f2 f874    LDI      #74
15f4 5b      STR      Rb
15f5 ab      PLO      Rb
15f6 f801    LDI      #01
15f8 5b      STR      Rb
15f9 f84b    LDI      #4b              ; R7=204b
15fb a7      PLO      R7
15fc d40d87  CALL     0d87             ; Q=1 for 64 ticks
15ff         DB       64

1600  ;$162a 
1600 07      LDN      R7
1601 ae      PLO      Re
1602  ;$1619 160a 
1602 7b      SEQ     
1603 d40900  CALL     0900             ; dial number
1606 f896    LDI      #96
1608 ab      PLO      Rb
1609 0b      LDN      Rb
160a ca1602  LBNZ     1602
160d d40d87  CALL     0d87             ; Q=1 for 0f ticks
1610         DB       0f

1611 2e      DEC      Re
1612 f876    LDI      #76
1614 ab      PLO      Rb
1615 f874    LDI      #74
1617 5b      STR      Rb
1618 8e      GLO      Re
1619 ca1602  LBNZ     1602
161c d40d87  CALL     0d87             ; Q=1 for 32 ticks
161f         DB       32

1620 f874    LDI      #74
1622 ab      PLO      Rb
1623 f80b    LDI      #0b
1625 5b      STR      Rb
1626 17      INC      R7
1627 87      GLO      R7
1628 fb4c    XRI      #4c
162a c21600  LBZ      1600
162d 06      LDN      R6
162e ff01    SMI      #01
1630 56      STR      R6
1631 ca15e4  LBNZ     15e4
1634 d40d87  CALL     0d87             ; Q=1 for 32 ticks
1637         DB       32

1638 c01351  LBR      1351
             
163b  ;$113b 
163b f84b    LDI      #4b              ; R6=204b
163d a6      PLO      R6
163e f80a    LDI      #0a              ; R8=200a
1640 a8      PLO      R8
1641 e8      SEX      R8
1642 46      LDA      R6
1643 73      STXD    
1644 06      LDN      R6
1645 58      STR      R8
1646 d40d87  CALL     0d87             ; Q=1 for 96 ticks
1649         DB       96

164a c01351  LBR      1351

164d  ;= zeroes upto 16ff

1700  ;= list of exeptional telephone numbers
1700  0A 06 01 01 00 00 00 83           ; 0611
      0A 06 0A 04 0A 07 00 81           ; 060407
1710  0A 0A 07 00 00 00 00 80           ; 007
      0A 06 08 0A 0A 08 00 02           ; 068008
1720  0A 0A 08 00 00 00 00 05           ; 008
      0A 0A 00 00 00 00 00 04           ; 00
1730  00

1731  ;= keyboard translation
1731  0C 07 04 01      ;  * 7 4 1
      0A 08 05 02      ;  0 8 5 2
      0B 09 06 03      ;  # 9 6 3

173d  ;= DTMF tone translation
173d  07 03            ;   00010001     1       3 2 1 0
      07 02            ;   00100001     2       . . .
      07 01            ;   01000001     3       1 2 3  - 7
      06 03            ;   00010010     4       4 5 6  - 6
      06 02            ;   00100010     5       7 8 9  - 5
      06 01            ;   01000010     6       * 0 #  - 4
      05 03            ;   00010100     7
      05 02            ;   00100100     8
      05 01            ;   01000100     9
      04 02            ;   00101000     0
      04 01            ;   01001000     #
      04 03            ;   00011000     *

1755  ;= decimal constants 10000,1000,100,10
1755  DWlh   2710 03E8 0064 000A

175d  DWhl   081D 0569 02B4      ; dec : 2077 1385 692
      DWhl   0932 0621 0310      ; dec : 2354 1569 784
      DWhl   0AD2 0736 039B      ; dec : 2770 1846 923

176f  04 06 02 FF      ;   01010100
      03 05 01 FF      ;   10101000

1777  ;= special tones
1777  01 07 08         ;   10000011
      02 07 08         ;   01000011
      03 07 08         ;   00100011
      04 07 08         ;   00010011
      01 02 05         ;   11001000
      01 02 06         ;   11000100
      01 02 07         ;   11000010
      01 02 08         ;   11000001

178f  ;= to get zero checksum
178f  00 BF




0000-0004    reset entry point
0005-0016    enter subroutine
0017-0022    return from subroutine
0023-0041    return from interrupt
0042-03ba    interrupt service

03bb-0638    ????
1000-164c    ????   main code

subroutines:
0700 - 083f,  calls 09e7  0d67  0d77

0900-09e6 :  each invocation different state
  0913-092e, 09e3, 0968
  092f-093d
  093e-094c
  094d-0962
  0963-0973, 09d5
  0974-0982
  0983-09b5
  09b6-09e6

09e7-09f9  : compute ROM (0000-1800) checksumbyte  in Re

0a00-0b4f :  each invocation different state
  0a10-0a3a     0a40, 0aea
  0a3b-0a53     0a59, 0aea
  0a54-0a78
  0a79-0a9f,0aa3-0ae8     0aa3, 0aea        call 0d67
  0aa0-0aa2,0b11
  0aea-0b4f            0a9c

0b50-0bf9       call 0900 0c00 0a00 0d77 0d67 0e61 0d91 0dda

0c00-0d23 :  each invocation different state
  0c...
0c52         2 params
  0cd3-0cf7
  0cf8-0d23

0d24-0d59    4 params Wlh[par3]=B[par2]*Wlh[par1]  (par4=0 -> W=B*B)
0d5a-0d66    2 params clear par2 bytes ending at [par1]
0d67-0d76    3 params Wlh[3]:=Wlh[1]+Wlh[2]
0d77-0d86    3 params Wlh[3]:=Wlh[1]-Wlh[2]
0d87-0d90    1 param  Q=1 for [1] irq's
0d91-0dd6    2 params convert Wlh[par1] -> BCD[par2] (3 bytes)
0dd7(0dda)-0dfb    1 param
0dfc-0e44    call 0d77 0d24
0e45-0e60    rotate bit from EF4 209e<<, status in 204a
0e61-0f95    call 0d24
0f96-0fbf

D1  is for output(40 times)
D2  is for output(at 0175)    input(15 times),
D3  is for output(twice)
D4  is for output(5 times),   input(22 times)
D5  is for output(at 0173)
D6  is for output(at 0174)
D7  is for output(6 times

