/*
   this deals with building the cross reference table
*/


struct addrlist {
  word addr;
  struct addrlist far *n;
};

struct xref {
  word ref;
  int type;
  struct addrlist far *list;
  struct xref far *n;
} far *xref;
#define REF_BRANCH 0
#define REF_JUMP 1
#define REF_CALL 2

int missedxrefs;

word minxref=0;
word maxxref=0xffff;

void addxref(int type, word addr, word ref)
{
  struct xref far *p;
  struct xref far *q;
  struct addrlist far *new;
  if (minxref>ref || ref>maxxref) return;
  new=(struct addrlist far *)farmalloc(sizeof(struct addrlist));
  if (new==NULL)  /* out of memory */
  {
    missedxrefs++;
    return;
  }
  new->addr=addr;

  p=xref;  q=NULL;
  while (p!=NULL &&
         (ref>p->ref ||
          (ref==p->ref && type!=p->type)
        ))
  {
    q=p; p=p->n;
  }

  if (p!=NULL && ref==p->ref && type==p->type)  /* new addr for ref */
  {
    new->n=p->list;
    p->list=new;
  }
  else /* insert */
  {
    new->n=NULL;
    if (q==NULL)
    {
      q=(struct xref far *)farmalloc(sizeof(struct xref));
      if (q==NULL)
      {
        missedxrefs++;
        farfree(new);
        return;
      }
      xref=q;
    }
    else
    {
      q->n=(struct xref far *)farmalloc(sizeof(struct xref));
      if (q->n==NULL)
      {
        missedxrefs++;
        farfree(new);
        return;
      }
      q=q->n;
    }
    q->n=p;
    q->list=new;
    q->ref=ref;
    q->type=type;
  }
}
